#INCLUDE "PROTHEUS.CH"
#INCLUDE "TBICONN.CH"                                                                                                                                     
#INCLUDE "TECA450.CH"


#DEFINE  CADASTRO STR0001 //"Ordem de Servico"
#DEFINE  NUMITENS 999

Static cPictureTot		//Picture dos campos de Totais do rodape da tela
Static oDlg				//Objeto dialog principal
Static oSay1		 	//Obj. Say do Total geral 
Static oSay2			//Obj. Say do Total cliente
Static oSay3			//Obj. Say do Total fabricante 

/*/

Ŀ
Funo     TECA450   Autor  Vendas Clientes        Data  03.10.98  
Ĵ
Descrio  Programa de atualizacao das O.S.                            
Ĵ
Sintaxe    Void TECA450(void)                                          
Ĵ
Uso        Generico                                                    
ٱ


/*/
User Function TECA450Lab( cRotina, xAutoCab, xAutoItens, xAutoApont, nOpcAuto )

Local cAt450Brw		:= ""		// Filtro fornecido pelo ponto de entrada
Local bFiltraBrw	:= {||}		// Bloco de cdigo para execuo do filtro
Local aIndexAB6		:= {}		// Indice do AB1
Local cFiltraAB6	:= ""		// Filtro utilizado no bloco de cdigo executado para ativar o filtro
Local aCores //:= {} 

Private cCadastro := CADASTRO

Private aRotina := MenuDef()

Private cRoda 							              
Private aAutoCab                                                                                       
Private aAutoItens
Private aAutoApont

U_PCPCORES()

aCores := { { 'AB6_STATUS == "E"', 'DISABLE' },;  
			{ 'AB6_STATUS == "C"', 'BR_AMARELO' },; 
			{ 'AB6_STATUS == "A"', 'ENABLE'    } } 
										
dbSelectArea("AB6")  

If	xAutoCab <> Nil .And. xAutoItens <> NIL
	Private lAt450Auto := .T.

	aAutoCab  := xAutoCab
	aAutoItens:= xAutoItens
	aAutoApont:= xAutoApont
	
	Default aAutoApont:= {}	

	MBrowseAuto(nOpcAuto,Aclone(aAutoCab),"AB6")
ElseIf ( AMIIn(28) )
	//Ŀ
	// Verifica a existencia de Filtros na mBrowse                  
	//
	AB6->(DbSetOrder(1))			
	If (ExistBlock("U_AT450Brw"))
		cAt450Brw := ExecBlock("U_AT450BRW",.F.,.F.)
		If ( ValType(cAt450Brw) == "C" ) .And. !Empty(cAt450Brw)
			cFiltraAB6 := cAt450Brw
		EndIf
		bFiltraBrw 	:= {|| FilBrowse("AB6",@aIndexAB6,@cFiltraAB6) }
		Eval(bFiltraBrw)
	EndIf

    If ValType( cRotina ) == "C"
   		//Ŀ
		// Faz tratamento para chamada por outra rotina             
		//
		cRotina := Upper( cRotina ) 
		If !Empty( nScan := AScan( aRotina, { |x| Upper( x[2] ) == cRotina } ) ) 
			cRoda := cRotina + "( 'AB6', AB6->( Recno() ), " + Str(nScan,2) + " )" 
			xRet  := Eval( { || &( cRoda ) } ) 
		EndIf 
	Else
		DbSetOrder(1)
		DbSeek(xFilial())
		mBrowse( 6, 1,22,75,"AB6",,,,,,aCores) //		mBrowse( 6, 1,22,75,"AB6",,,,"AB6_STATUS=='A'")
	EndIf     
EndIf
DbSelectArea("AB6")
DbSetOrder(1)
Return(.T.)

/*/

Ŀ
Funo    MenuDef    Autor  Vendas Clientes        Data  08.12.06 
Ĵ
Descrio  Definio do aRotina (Menu funcional)                      
Ĵ
Sintaxe    MenuDef()                                                  
Ĵ
Parametros                                                            
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
Static Function MenuDef()
	//Ŀ
	// Define Array contendo as Rotinas a executar do programa      
	// ----------- Elementos contidos por dimensao ------------     
	// 1. Nome a aparecer no cabecalho                              
	// 2. Nome da Rotina associada                                  
	// 3. Usado pela rotina                                         
	// 4. Tipo de Transao a ser efetuada                          
	//    1 - Pesquisa e Posiciona em um Banco de Dados             
	//    2 - Simplesmente Mostra os Campos                         
	//    3 - Inclui registros no Bancos de Dados                   
	//    4 - Altera o registro corrente                            
	//    5 - Remove o registro corrente do Banco de Dados          
	//
	Local aRotina := {	{STR0002	,"AxPesqui"		,0	,1	,0	,.F.	}	,;	//"Pesquisar"
						{"Visualizar"	,"U_AT450Visua"	,0	,2	,0	,.T.	}	,;	//"Visualizar" 
						{"Exclui"	,"U_AT450Exclu"	,0	,9	,0	,.T.	}	,;
						{"Alterar"	,"U_AT450Alter"	,0	,4	,0	,.T.	},;//"Exclui"
						{"Gera PV.","U_GERAORC" 	,0	,3	,0	,.T.	}	,;//
						{"Gera Orc.","U_GTGERORC" 	,0	,5	,0	,.T.	}	,;						
						{"Legenda"	,"U_At450Leg"  	,0	,10	,0	,.T.	}	,; 	//"Legenda"
						{"Imprime Oramento","U_RFATR001"  	,0	,7	,0	,.T.	}	,; 	//"Legenda"
					  	{"Efetiva"	,"U_AT450Efet" 	,0	,8	,0	,.T.	},;
					  	{"Pendencias","U_GTPEN01" 	,0	,11	,0	,.T.	}}	//"Alterar"
					  //	{STR0004	,"U_AT450Inclu"	,0	,3	,0	,.T.	}	,;	//"Incluir"

					
						
	Local aRotAdic    := {}  //aRotina adicional para o ponto de entrada						
	
	//Ŀ
	// Ponto de entrada - Adiciona rotinas ao aRotina       
	//
	If ExistBlock("TC450ROT")
		aRotAdic := ExecBlock("TC450ROT", .F., .F.)
		If ValType(aRotAdic) == "A"
			AEval(aRotAdic,{|x| aAdd(aRotina,x)})
		EndIf
	EndIf
Return(aRotina)

/*/


Ŀ
Funo    AT450Inclu Autor  Vendas Clientes        Data 03.10.98  
Ĵ
Descrio  Programa de Inclusao de Ordem de Servico                   
Ĵ
Sintaxe e  Void AT450Inclu(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450Inclu(cAlias,nReg,nOpcx)

Local nUsado	:= 0
Local nPosItem	:= 0
Local nOpcA		:= 0
Local aArea		:= { Alias(), IndexOrd() , Recno() }
Local uCampo	:= ""
Local oGetD		:= Nil
Local lGrava	:= .T. 
Local lBlockRet	:= Nil
Local aObjects	:= {} 
Local aPosObj	:= {} 
Local aSizeAut	:= {}
Local aPosGet	:= {} 
//Local nSaveSX8	:= GetSX8Len()
Local nCntFor	:= 0
Local n1		:= 0				//Total Geral
Local n2     	:= 0				//Total Cliente
Local n3 		:= 0				//Total Fabricante

If ExistBlock("U_AT450INC")
	Execblock("U_AT450INC",.F.,.F.)
Endif

Private aTela		:= {}
Private aGets		:= {}
Private aHeader		:= {}
Private aHeaderAB8	:= {}
Private aHeaderAB7	:= {}
Private aCols		:= {}
Private aColsAB8	:= {}
Private nOpcF4		:= nOpcX

//Ŀ
// Inicializa as Variaveis da Enchoice                          
//
DbSelectArea("SX3")
DbSetOrder(1)
DbSeek("AB6")
While ( !Eof() .And. SX3->X3_ARQUIVO == "AB6" )
	uCampo := SX3->X3_CAMPO
	M->&(uCampo) := CriaVar(uCampo,.T.)
	DbSelectArea("SX3")
	DbSkip()
EndDo

//Ŀ
// Monta aHeader                                                
//
U_AT450Monta()

//Ŀ
// Monta aCols                                                  
//
aHeader  := aClone(aHeaderAB7)
nUsado   := Len(aHeader)
nPosItem := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_ITEM"})
aAdd(aCols,Array(nUsado+1))
For nCntFor := 1 To nUsado
	If IsHeadRec(aHeader[nCntFor][2])
		aCols[1][nCntFor] := 0
	Elseif IsHeadAlias(aHeader[nCntFor][2])
		aCols[1][nCntFor] := "AB7"
	Else
		aCols[1][nCntFor] := CriaVar(aHeader[nCntFor][2])
	Endif
Next nCntFor
aCols[1][nPosItem] := "01"
aCols[1][nUsado+1] := .F.

//
// Atualiza picture 
//
cPictureTot	:= PesqPict("AB8","AB8_TOTAL",14,M->AB6_MOEDA) 

If Type("lAt450Auto")=="U" .Or. !lAt450Auto
	
	aSizeAut := MsAdvSize()
	//Ŀ
	// Habilita a Tecla F4                                          
	//
	SetKey(VK_F4,{||U_AT450F4(oGetD)})
	                                    
	aObjects := {} 
	aAdd( aObjects, { 315,  70, .T., .t. } )
	aAdd( aObjects, { 100, 100, .t., .t. } )
	aAdd( aObjects, { 100,   7, .t., .f. } )
	
	aInfo := { aSizeAut[ 1 ], aSizeAut[ 2 ], aSizeAut[ 3 ], aSizeAut[ 4 ], 3, 3 } 
	
	aPosObj := MsObjSize( aInfo, aObjects ) 
	
	//Ŀ
	//Monta tela de entrada                                                   
	//
	DEFINE MSDIALOG oDlg TITLE CADASTRO FROM aSizeAut[7],0 TO aSizeAut[6],aSizeAut[5] PIXEL 
	
	EnChoice( "AB6" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.T.)
	oGetD := MsGetDados():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_AT450LinOk","U_AT450TudOk","+AB7_ITEM",.T.,,,,NUMITENS)
	
	nLinIni := aPosObj[ 3, 1 ] 
	
	aPosGet := MsObjGetPos(aSizeAut[3]-aSizeAut[1],310,;
				{{005,065,105,165,205,265}} )
	
	@ nLinIni,aPosGet[1,1] SAY STR0011 SIZE 60,09 OF oDlg PIXEL //"Total: "
	@ nLinIni,aPosGet[1,2] SAY oSay1 VAR Transform(n1, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
	@ nLinIni,aPosGet[1,3] SAY STR0012 SIZE 60,09 OF oDlg PIXEL //"Total do Cliente: "
	@ nLinIni,aPosGet[1,4] SAY oSay2 VAR Transform(n2, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
	@ nLinIni,aPosGet[1,5] SAY STR0013 SIZE 60,09 OF oDlg PIXEL //"Total do Fabricante: "
	@ nLinIni,aPosGet[1,6] SAY oSay3 VAR Transform(n3, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
	oDlg:Cargo := {|n1,n2,n3| 	oSay1:SetText( Transform(n1, cPictureTot) ),;
								oSay2:SetText( Transform(n2, cPictureTot) ),;
								oSay3:SetText( Transform(n3, cPictureTot) ) }
	At450Total(oDlg,.F.)
	ACTIVATE MSDIALOG oDlg ON INIT AT450Bar(oDlg,{||nOpca:=1,if(oGetD:TudoOk().And.Obrigatorio(aGets,aTela),oDlg:End(),nOpca:=0)},{||oDlg:End()},nOpcx,oGetD)
	//Ŀ
	// Desabilita a Tecla F4                                        
	//
	SetKey(VK_F4,Nil)
Else
	If EnchAuto(cAlias,aAutoCab,{|| Obrigatorio(aGets,aTela)}) .And.;
		MsGetDAuto(aAutoItens,"U_AT450LinOk",{|| U_AT450TudOk() },aAutoCab,aRotina[nOpcX][4]) .And. U_At450F4()
		nOpcA := 1
	EndIf
EndIf

If ( nOpcA == 1 )      

	//Ŀ
	// Roda o ponto de entrada para verificar se pode incluir       
	//
	If ExistBlock( "U_AT450OKI" )
   		lBlockRet := ExecBlock( "U_AT450OKI", .F., .F. ) 
   		lGrava    := If( ValType( lBlockRet ) == "L", lBlockRet, lGrava ) 		
    EndIf 
	
	If lGrava 	
		Begin Transaction
			If ( AT450Grava(1) )
				EvalTrigger()
/*				While ( GetSX8Len() > nSaveSx8 )
					ConfirmSX8()
				EndDo*/
			EndIf
		End Transaction
	EndIf 	
		
EndIf

/*While ( GetSX8Len() > nSaveSx8 )
	RollBackSX8()
EndDo*/

DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])

Return(.T.)

/*/


Ŀ
Funo    AT450Visua Autor  Vendas Clientes        Data 03.10.98  
Ĵ
Descrio  Programa de Visualizacao de Ordem de Servico               
Ĵ
Sintaxe e  Void AT450Visua(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450Visua(cAlias,nReg,nOpcx)

Local nUsado	:= 0
Local nCntFor2	:= 0
Local nOpcA		:= 0
Local aArea		:= { Alias(), IndexOrd() , Recno() }
Local uCampo	:= ""
Local aAux		:= {}
Local nPosItem	:= 0
Local oGetD		:= Nil
Local aObjects	:= {} 
Local aPosObj	:= {} 
Local aSizeAut	:= MsAdvSize()
Local aPosGet	:= {} 
Local nCntFor	:= 0
Local n1		:= 0				//Total Geral
Local n2		:= 0				//Total Cliente
Local n3		:= 0				//Total Fabricante

If ExistBlock("U_AT450VIS")
	Execblock("U_AT450VIS",.F.,.F.)
Endif

Private aTela		:= {}
Private aGets		:= {}
Private aHeader		:= {}
Private aHeaderAB8	:= {}
Private aHeaderAB7	:= {}
Private aCols		:= {}
Private aColsAB8	:= {}
Private nOpcF4		:= nOpcX

//Ŀ
// Inicializa as Variaveis da Enchoice                          
//
DbSelectArea("SX3")
DbSetOrder(1)
DbSeek("AB6")
While ( !Eof() .And. SX3->X3_ARQUIVO == "AB6" )
	uCampo := SX3->X3_CAMPO
	If ( SX3->X3_CONTEXT == "V" )
		M->&(uCampo) := CriaVar(uCampo,.T.)
	Else
		M->&(uCampo) := AB6->(FieldGet(FieldPos(uCampo)))
	EndIf
	DbSelectArea("SX3")
	DbSkip()
EndDo

//Ŀ
// Monta aHeader                                                
//
U_AT450Monta()

//Ŀ
// Monta aCols                                                  
//
aHeader  := aClone(aHeaderAB7)
nUsado   := Len(aHeader)
nPosItem := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_SUBITE"})
DbSelectArea("AB7")
DbSetOrder(1)
DbSeek(xFilial("AB7")+AB6->AB6_NUMOS)
While ( !Eof() .And. xFilial("AB7")    == AB7->AB7_FILIAL .And.;
							AB6->AB6_NUMOS == AB7->AB7_NUMOS )
	aAdd(aCols,Array(nUsado))
	For nCntFor := 1 To nUsado
		If IsHeadRec(aHeader[nCntFor][2])
			aCols[Len(aCols)][nCntFor] := AB7->(RecNo())
		Elseif IsHeadAlias(aHeader[nCntFor][2])
			aCols[Len(aCols)][nCntFor] := "AB7"
		Elseif ( aHeader[nCntFor][10] <> "V" )
			aCols[Len(aCols)][nCntFor] := FieldGet(FieldPos(aHeader[nCntFor][2]))
		Else
			aCols[Len(aCols)][nCntFor] := CriaVar(aHeader[nCntFor][2])
		EndIf
	Next nCntFor
	aAux := {}
	DbSelectArea("AB8")
	DbSetOrder(1)
	If ( DbSeek(xFilial("AB8")+AB6->AB6_NUMOS+AB7->AB7_ITEM) )
		While ( !Eof() .And. xFilial("AB8") == AB8->AB8_FILIAL .And.;
									M->AB6_NUMOS   == AB8->AB8_NUMOS .And.;
									AB7->AB7_ITEM== AB8->AB8_ITEM )
			aAdd(aAux,Array(Len(aHeaderAB8)+1))
			For nCntFor := 1 To Len(aHeaderAB8)
				If IsHeadRec(aHeaderAB8[nCntFor][2])
					aAux[Len(aAux)][nCntFor] := AB8->(RecNo())
				Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
					aAux[Len(aAux)][nCntFor] := "AB8"
				Elseif ( aHeaderAB8[nCntFor][10] <> "V" )
					aAux[Len(aAux)][nCntFor] := FieldGet(FieldPos(aHeaderAB8[nCntFor][2]))
				Else
					aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
				EndIf
			Next nCntFor
			aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
			DbSelectArea("AB8")
			DbSkip()
		EndDo
		aAdd(aColsAB8,aClone(aAux))
	Else
		aAdd(aAux,Array(Len(aHeaderAB8)+1))
		For nCntFor := 1 To Len(aHeaderAB8)
			If IsHeadRec(aHeaderAB8[nCntFor][2])
				aAux[Len(aAux)][nCntFor] := 0
			Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
				aAux[Len(aAux)][nCntFor] := "AB8"
			Else
				aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
			Endif
		Next nCntFor
		aAux[Len(aAux)][nPosItem] := "01"
		aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
		aAdd(aColsAB8,aClone(aAux))
	EndIf
	DbSelectArea("AB7")
	DbSkip()
EndDo
//Ŀ
// Habilita a Tecla F4                                          
//
SetKey(VK_F4,{||U_AT450F4(oGetD)})

aObjects := {} 
aAdd( aObjects, { 315,  70, .T., .t. } )
aAdd( aObjects, { 100, 100, .t., .t. } )
aAdd( aObjects, { 100,   7, .t., .f. } )
aInfo := { aSizeAut[ 1 ], aSizeAut[ 2 ], aSizeAut[ 3 ], aSizeAut[ 4 ], 3, 3 } 
aPosObj := MsObjSize( aInfo, aObjects ) 

//
// Atualiza picture 
//
cPictureTot	:= PesqPict("AB8","AB8_TOTAL",14,M->AB6_MOEDA) 

//Ŀ
//Monta tela de entrada                                                   
//
DEFINE MSDIALOG oDlg TITLE CADASTRO FROM aSizeAut[7],0 TO aSizeAut[6],aSizeAut[5] PIXEL 

EnChoice( "AB6" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.T.)
oGetD := MsGetDados():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_AT450LinOk","U_AT450TudOk","+AB7_ITEM",.F.)

nLinIni := aPosObj[3,1] 

aPosGet := MsObjGetPos(aSizeAut[3]-aSizeAut[1],310,;
			{{005,065,105,165,205,265}} )

@ nLinIni,aPosGet[1,1] SAY STR0011 SIZE 60,09 OF oDlg PIXEL //"Total: "
@ nLinIni,aPosGet[1,2] SAY oSay1 VAR Transform(n1, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
@ nLinIni,aPosGet[1,3] SAY STR0012 SIZE 60,09 OF oDlg PIXEL //"Total do Cliente: "
@ nLinIni,aPosGet[1,4] SAY oSay2 VAR Transform(n2, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
@ nLinIni,aPosGet[1,5] SAY STR0013 SIZE 60,09 OF oDlg PIXEL //"Total do Fabricante: "
@ nLinIni,aPosGet[1,6] SAY oSay3 VAR Transform(n3, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
oDlg:Cargo := {|n1,n2,n3| 	oSay1:SetText( Transform(n1, cPictureTot) ),;
							oSay2:SetText( Transform(n2, cPictureTot) ),;
							oSay3:SetText( Transform(n3, cPictureTot) ) }
At450Total(oDlg,.F.)
ACTIVATE MSDIALOG oDlg ON INIT AT450Bar(oDlg,{||oDlg:End()},{||oDlg:End()},nOpcx,oGetD)

//Ŀ
// Desabilita a Tecla F4                                        
//
SetKey(VK_F4,Nil)
DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])
Return(.T.)

/*/


Ŀ
Funo    ALTER450 Autor  Vendas Clientes        Data 03.10.98  
Ĵ
Descrio  Programa de Alteracao de Ordem de Servico                  
Ĵ
Sintaxe e  Void AT450Alter(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450Alter(cAlias,nReg,nOpcx)

Local nUsado	:= 0
Local nCntFor2	:= 0
Local nOpcA		:= 0
Local aArea		:= { Alias(), IndexOrd() , Recno() }
Local uCampo	:= ""
Local aAux		:= {}
Local aTravas	:= {}
Local lTravas	:= .T.
Local nPosItem	:= 0
Local nPosCPrb  := 0
Local nPosCodP  := 0
Local nPosOrca  := 0
Local nPosNorc  := 0
Local nPosDtOr  := 0
Local nPosHror  := 0
Local nPosApro  := 0
Local nPosDtAp  := 0
Local nPosHrap  := 0
Local nPosLibf  := 0
Local nPosDtLi  := 0
Local nPosHrLi  := 0
Local nPosServ  := 0
Local nPosProd  := 0
Local nPosValo  := 0
Local nPosCfre  := 0
Local nPosTfre  := 0
Local nPosTran  := 0
Local nPosVfre  := 0
Local nPosSemr  := 0
Local oGetD		:= Nil
Local lGrava	:= .T.
Local lBlockRet	:= Nil
Local aObjects	:= {} 
Local aPosObj	:= {} 
Local aSizeAut	:= {}
Local aPosGet	:= {} 
//Local nSaveSX8	:= GetSX8Len()
Local nCntFor	:= 0  
Local n1		:= 0				//Total Geral
Local n2		:= 0				//Total Cliente
Local n3		:= 0				//Total Fabricante

If ExistBlock("U_AT450ALT")
	Execblock("U_AT450ALT",.F.,.F.)
Endif

Private aTela		:= {}
Private aGets		:= {}
Private aHeader		:= {}
Private aHeaderAB8	:= {}
Private aHeaderAB7	:= {}
Private aCols		:= {}
Private aColsAB8	:= {}
Private nOpcF4		:= nOpcX

//Ŀ
// Inicializa as Variaveis da Enchoice                          
//  


DbSelectArea("SX3")
DbSetOrder(1)
DbSeek("AB6")
While ( !Eof() .And. SX3->X3_ARQUIVO == "AB6" )
	uCampo := SX3->X3_CAMPO
	If ( SX3->X3_CONTEXT == "V" )
		M->&(uCampo) := CriaVar(uCampo,.T.)
	Else
		M->&(uCampo) := AB6->(FieldGet(FieldPos(uCampo)))
	EndIf
	DbSelectArea("SX3")
	DbSkip()
EndDo

//Ŀ
//Trava Registros                                                         
//
If ( !AtTravaReg("AB6", aTravas) )
	lTravas := .F.
Endif

//Ŀ
// Monta aHeader                                                
//
U_AT450Monta()

//Ŀ
// Monta aCols                                                  
//
aHeader  := aClone(aHeaderAB7)
nUsado   := Len(aHeader)
nPosItem := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_ITEM"})
nPosCPrb := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_CODPRB"})
nPosCodP := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XCODPG"})
nPosOrca := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XORC"})
nPosNorc := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XNORC"})
nPosDtOr := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XDTORC"})
nPosHror := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XHRORC"})
nPosApro := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XAPROV"})
nPosDtAp := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XDTAPR"})
nPosHrap := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XHRAPR"})
nPosLibf := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XLIBFI"})
nPosDtLi := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XDTLIB"})
nPosHrLi := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XHLIB"})
nPosServ := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XSERVI"})
nPosProd := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_CODPRO"})
nPosValo := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XVALOR"})
nPosCfre := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XCFRET"})
nPosTfre := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XTFRET"})
nPosTran := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XTRANS"})
nPosVfre := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XVFRET"})
nPosSemr := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_XSEMRE"})					                                                 

DbSelectArea("AB7")
DbSetOrder(1)
DbSeek(xFilial("AB7")+AB6->AB6_NUMOS)
While ( !Eof() .And. xFilial("AB7")    == AB7->AB7_FILIAL .And.;
							AB6->AB6_NUMOS == AB7->AB7_NUMOS )
	If ( !AtTravaReg("AB7", aTravas) )
		lTravas := .F.
	Endif

	aAdd(aCols,Array(nUsado+1))
	For nCntFor := 1 To nUsado
		If IsHeadRec(aHeader[nCntFor][2])
			aCols[Len(aCols)][nCntFor] := AB7->(RecNo())
		Elseif IsHeadAlias(aHeader[nCntFor][2])
			aCols[Len(aCols)][nCntFor] := "AB7"
		Elseif ( aHeader[nCntFor][10] <> "V" )
			aCols[Len(aCols)][nCntFor] := FieldGet(FieldPos(aHeader[nCntFor][2]))
		Else
			aCols[Len(aCols)][nCntFor] := CriaVar(aHeader[nCntFor][2])
		EndIf
	Next nCntFor
	aCols[Len(aCols)][nUsado+1] := .F.
	aAux := {}
	DbSelectArea("AB8")
	DbSetOrder(1)
	If ( DbSeek(xFilial("AB8")+AB6->AB6_NUMOS+AB7->AB7_ITEM) )
		While ( !Eof() .And. xFilial("AB8") == AB8->AB8_FILIAL .And.;
									M->AB6_NUMOS   == AB8->AB8_NUMOS .And.;
									AB7->AB7_ITEM== AB8->AB8_ITEM )
			If ( !AtTravaReg("AB8", aTravas) )
				lTravas := .F.
			Endif

			aAdd(aAux,Array(Len(aHeaderAB8)+1))
			For nCntFor := 1 To Len(aHeaderAB8)
				If IsHeadRec(aHeaderAB8[nCntFor][2])
					aAux[Len(aAux)][nCntFor] := AB8->(RecNo())
				Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
					aAux[Len(aAux)][nCntFor] := "AB8"
				Elseif ( aHeaderAB8[nCntFor][10] <> "V" )
					aAux[Len(aAux)][nCntFor] := FieldGet(FieldPos(aHeaderAB8[nCntFor][2]))
				Else
					aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
				EndIf
			Next nCntFor
			aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
			DbSelectArea("AB8")
			DbSkip()
		EndDo
		aAdd(aColsAB8,aClone(aAux))
	Else
		aAdd(aAux,Array(Len(aHeaderAB8)+1))
		For nCntFor := 1 To Len(aHeaderAB8)
			If IsHeadRec(aHeaderAB8[nCntFor][2])
				aAux[Len(aAux)][nCntFor] := 0
			Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
				aAux[Len(aAux)][nCntFor] := "AB8"
			Else
				aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
			Endif
		Next nCntFor
		aAux[Len(aAux)][nPosItem] := "01"
		aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
		aAdd(aColsAB8,aClone(aAux))
	EndIf
	DbSelectArea("AB7")
	DbSkip()
EndDo

//Ŀ
// Posiciona o cliente                                          
//
SA1->( DbSetOrder( 1 ) ) 
SA1->( DbSeek( xFilial( "SA1" ) + M->AB6_CODCLI + M->AB6_LOJA ) ) 

//
// Atualiza picture 
//
cPictureTot	:= PesqPict("AB8","AB8_TOTAL",14,M->AB6_MOEDA) 

If ( lTravas )
	If Type("lAt450Auto")=="U" .Or. !lAt450Auto
		
		aSizeAut := MsAdvSize()	

		//Ŀ
		// Habilita a Tecla F4                                          
		//
		SetKey(VK_F4,{||U_AT450F4(oGetD)})
	
		aObjects := {} 
		aAdd( aObjects, { 315,  70, .T., .t. } )
		aAdd( aObjects, { 100, 100, .t., .t. } )
		aAdd( aObjects, { 100,   7, .t., .f. } )
		aInfo := { aSizeAut[ 1 ], aSizeAut[ 2 ], aSizeAut[ 3 ], aSizeAut[ 4 ], 3, 3 } 
		aPosObj := MsObjSize( aInfo, aObjects ) 
		
		//Ŀ
		//Monta tela de entrada                                                   
		//
		DEFINE MSDIALOG oDlg TITLE CADASTRO FROM aSizeAut[7],0 TO aSizeAut[6],aSizeAut[5] PIXEL 
	
		// DEFINE MSDIALOG oDlg TITLE CADASTRO From 9,0 to 28,80
		EnChoice( "AB6" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.T.)
		oGetD := MsGetDados():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_AT450LinOk","U_AT450TudOk","+AB7_ITEM",.T.,,,,NUMITENS)
		
		nLinIni := aPosObj[3,1]
		
		aPosGet := MsObjGetPos(aSizeAut[3]-aSizeAut[1],310,;
				{{005,065,105,165,205,265}} )
		
		@ nLinIni,aPosGet[1,1] SAY STR0011 SIZE 60,09 OF oDlg PIXEL //"Total: "
		@ nLinIni,aPosGet[1,2] SAY oSay1 VAR Transform(n1, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
		@ nLinIni,aPosGet[1,3] SAY STR0012 SIZE 60,09 OF oDlg PIXEL //"Total do Cliente: "
		@ nLinIni,aPosGet[1,4] SAY oSay2 VAR Transform(n2, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
		@ nLinIni,aPosGet[1,5] SAY STR0013 SIZE 60,09 OF oDlg PIXEL //"Total do Fabricante: "
		@ nLinIni,aPosGet[1,6] SAY oSay3 VAR Transform(n3, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
		oDlg:Cargo := {|n1,n2,n3| 	oSay1:SetText( Transform(n1, cPictureTot) ),;
									oSay2:SetText( Transform(n2, cPictureTot) ),;
									oSay3:SetText( Transform(n3, cPictureTot) ) }
		At450Total(oDlg,.F.)
		ACTIVATE MSDIALOG oDlg ON INIT AT450Bar(oDlg,{||nOpca:=1,if(oGetD:TudoOk().And.Obrigatorio(aGets,aTela),oDlg:End(),nOpca:=0)},{||oDlg:End()},nOpcx,oGetD)
		//Ŀ
		// Desabilita a Tecla F4                                        
		//
		SetKey(VK_F4,Nil)
	Else
		If EnchAuto(cAlias,aAutoCab,{|| Obrigatorio(aGets,aTela)}) .And.;
			MsGetDAuto(aAutoItens,"U_AT450LinOk",{|| U_AT450TudOk() },aAutoCab,aRotina[nOpcX][4]) .And. U_At450F4()
			nOpcA := 1
		EndIf
	EndIf
EndIf    
nOpcA := 1
If ( nOpcA == 1 )
	
	//Ŀ
	// Roda o ponto de entrada para verificar se pode alterar       
	//
	If ExistBlock( "U_AT450OKA" )
   		lBlockRet := ExecBlock( "U_AT450OKA", .F., .F. ) 
   		lGrava    := If( ValType( lBlockRet ) == "L", lBlockRet, lGrava ) 		
    EndIf 

	If lGrava 		
		Begin Transaction           
			//If ( AT450Grava(2)  )
			//	EvalTrigger()                  
			If Reclock("AB6",.F.)
 		       AB6->AB6_CONPAG  := M->AB6_CONPAG
 		       AB6->AB6_XFATUR  := M->AB6_XFATUR        
			   AB6->AB6_XEMAIL  := M->AB6_XEMAIL         		   
			   AB6->AB6_XCONTA  := M->AB6_XCONTA			       
 		       Msunlock()
 			EndIf                                 
 			
	 		DbSelectArea("AB7")
	 		DbSetOrder(1)	      
	 		
			For n:= 1 to Len(aCols)                                           
		 		If Dbseek(xFilial("AB7")+AB6->AB6_NUMOS+aCols[n,nPosItem]) 			
//					If !Empty(aCols[n,]) 	
		 			   Reclock ("AB7",.F.)
		 			   AB7->AB7_FILIAL := xFilial("AB7")		 			   
		 			   AB7->AB7_CODPRB := aCols[n,nPosCPrb]
					   AB7->AB7_XCODPG := aCols[n,nPosCodP]		 			   
					   AB7->AB7_XORC   := aCols[n,nPosOrca]  	
					   AB7->AB7_XNORC  := aCols[n,nPosNorc]						   	 			   					   
//					   AB7->AB7_XDTORC := aCols[n,nPosDtOr]						   	 			   					   					   
					   AB7->AB7_XHRORC := aCols[n,nPosHror]						   	 			   					   					   					   
					   AB7->AB7_XAPROV := aCols[n,nPosApro]		 			   					   					   
					   AB7->AB7_XDTAPR := aCols[n,nPosDtAp]		 			   					   					   					   
					   AB7->AB7_XHRAPR := aCols[n,nPosHrap]		 			   					   					   					   					   
					   AB7->AB7_XLIBFI := aCols[n,nPosLibf]		 			   					   					   					   					   
					   AB7->AB7_XDTLIB := aCols[n,nPosDtLi]		 			   					   					   					   					   
					   AB7->AB7_XHLIB  := aCols[n,nPosHrLi]
					   AB7->AB7_XSERVI := aCols[n,nPosServ] 		 			   					   					   					   					   					   					   
					   AB7->AB7_CODPRO := aCols[n,nPosProd]   
					   AB7->AB7_XVALOR := aCols[n,nPosValo]   
                       AB7->AB7_XCFRET := aCols[n,nPosCfre]   					   
                       AB7->AB7_XTFRET := aCols[n,nPosTfre]   					   
                       AB7->AB7_XTRANS := aCols[n,nPosTran]   					                          
                       AB7->AB7_XVFRET := aCols[n,nPosVfre]   					                          
   				       AB7->AB7_XSEMRE := aCols[n,nPosSemr]   					                                                 				                                                 
		 			   MsUnlock()	                                                    
  //	                EndIf	 		    	
		  		EndIf
		 	Next n	
				/*While ( GetSX8Len() > nSaveSx8 )
					ConfirmSX8()
				EndDo*/
		//	EndIf
		End Transaction
	EndIf 				
EndIf
/*While ( GetSX8Len() > nSaveSx8 )
	RollBackSX8()
EndDo*/

//Ŀ
//Efetua o destravamento dos registros travados.
//
AtDestravaReg( aTravas )

DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])

Return(.T.)

/*/


Ŀ
Funo    AT450Exclu Autor  Vendas Clientes        Data 03.10.98  
Ĵ
Descrio  Programa de Exclusao  de Ordem de Servico                  
Ĵ
Sintaxe e  Void AT450Exclu(ExpC1,ExpN1,ExpN2)                         
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Opcao selecionada                                  
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450Exclu(cAlias,nReg,nOpcx)

Local nUsado	:= 0
Local nCntFor2	:= 0
Local nOpcA		:= 0
Local aArea		:= { Alias(), IndexOrd() , Recno() }
Local uCampo	:= ""
Local aAux		:= {}
Local aTravas	:= {}
Local lTravas	:= .T.
Local lExclui	:= .T.
Local nPosItem	:= 0
Local oGetD		:= Nil
Local lGrava	:= .T. 
Local lBlockRet	:= Nil 
Local aObjects	:= {} 
Local aPosObj	:= {} 
Local aSizeAut	:= {}
Local aPosGet	:= {}
//Local nSaveSX8	:= GetSX8Len()
Local nCntFor	:= 0 
Local n1		:= 0				//Total Geral
Local n2     	:= 0				//Total Cliente
Local n3 		:= 0				//Total Fabricante

If ExistBlock("U_AT450EXC")
	Execblock("U_AT450EXC",.F.,.F.)
Endif

Private aTela		:= {}
Private aGets		:= {}
Private aHeader		:= {}
Private aHeaderAB8	:= {}
Private aHeaderAB7	:= {}
Private aCols		:= {}
Private aColsAB8	:= {}
Private nOpcF4		:= nOpcX

If ( Eof() .Or. Bof() )
	Return(.F.)
EndIf

//Ŀ
// Inicializa as Variaveis da Enchoice                          
//
DbSelectArea("SX3")
DbSetOrder(1)
DbSeek("AB6")
While ( !Eof() .And. SX3->X3_ARQUIVO == "AB6" )
	uCampo := SX3->X3_CAMPO
	If ( SX3->X3_CONTEXT == "V" )
		M->&(uCampo) := CriaVar(uCampo,.T.)
	Else
		M->&(uCampo) := AB6->(FieldGet(FieldPos(uCampo)))
	EndIf
	DbSelectArea("SX3")
	DbSkip()
EndDo

//Ŀ
//Trava Registros                                                         
//
If ( !AtTravaReg("AB6", aTravas) )
	lTravas := .F.
Endif

//Ŀ
// Monta aHeader                                                
//
U_AT450Monta()

//Ŀ
// Monta aCols                                                  
//
aHeader  := aClone(aHeaderAB7)
nUsado   := Len(aHeader)
nPosItem := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_ITEM"})
DbSelectArea("AB7")
DbSetOrder(1)
DbSeek(xFilial("AB7")+AB6->AB6_NUMOS)
While ( !Eof() .And. xFilial("AB7")    == AB7->AB7_FILIAL .And.;
							AB6->AB6_NUMOS == AB7->AB7_NUMOS .And. lExclui )
	If ( AtTravaReg("AB7", aTravas) )
		If ( AB7->AB7_TIPO<>"1" )
			lExclui := .F.
			Help(" ",1,"AT450DEL01")
		EndIf
	Else
		lTravas := .F.
	EndIf
	aAdd(aCols,Array(nUsado))
	aAdd(aColsAB8,aClone(aAux))
	For nCntFor := 1 To nUsado
		If IsHeadRec(aHeader[nCntFor][2])
			aCols[Len(aCols)][nCntFor] := AB7->(RecNo())
		Elseif IsHeadAlias(aHeader[nCntFor][2])
			aCols[Len(aCols)][nCntFor] := "AB7"
		Elseif ( aHeader[nCntFor][10] <> "V" )
			aCols[Len(aCols)][nCntFor] := FieldGet(FieldPos(aHeader[nCntFor][2]))
		Else
			aCols[Len(aCols)][nCntFor] := CriaVar(aHeader[nCntFor][2])
		EndIf
	Next nCntFor
	aAux := {}
	DbSelectArea("AB8")
	DbSetOrder(1)
	If ( DbSeek(xFilial("AB8")+AB6->AB6_NUMOS+AB7->AB7_ITEM) )
		While ( !Eof() .And. xFilial("AB8") == AB8->AB8_FILIAL .And.;
									M->AB6_NUMOS   == AB8->AB8_NUMOS .And.;
									AB7->AB7_ITEM== AB8->AB8_ITEM )
			If ( !AtTravaReg("AB8" , aTravas) )
				lTravas := .F.
			EndIf
			aAdd(aAux,Array(Len(aHeaderAB8)+1))
			For nCntFor := 1 To Len(aHeaderAB8)
				If IsHeadRec(aHeaderAB8[nCntFor][2])
					aAux[Len(aAux)][nCntFor] := AB8->(RecNo())
				Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
					aAux[Len(aAux)][nCntFor] := "AB8"
				Elseif ( aHeaderAB8[nCntFor][10] <> "V" )
					aAux[Len(aAux)][nCntFor] := FieldGet(FieldPos(aHeaderAB8[nCntFor][2]))
				Else
					aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
				EndIf
			Next nCntFor
			aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
			DbSelectArea("AB8")
			DbSkip()
		EndDo
		aAdd(aColsAB8,aClone(aAux))
	Else
		aAdd(aAux,Array(Len(aHeaderAB8)+1))
		For nCntFor := 1 To Len(aHeaderAB8)
			If IsHeadRec(aHeaderAB8[nCntFor][2])
				aAux[Len(aAux)][nCntFor] := 0
			Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
				aAux[Len(aAux)][nCntFor] := "AB8"
			Else		
				aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
			Endif
		Next nCntFor
		aAux[Len(aAux)][nPosItem] := "01"
		aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
		aAdd(aColsAB8,aClone(aAux))
	EndIf
	DbSelectArea("AB7")
	DbSkip()
EndDo

//
// Atualiza picture 
//
cPictureTot	:= PesqPict("AB8","AB8_TOTAL",14,M->AB6_MOEDA) 

If ( lTravas .And. lExclui )
	If Type("lAt450Auto")=="U" .Or. !lAt450Auto

		aSizeAut := MsAdvSize()	
		
		//Ŀ
		// Habilita a Tecla F4                                          
		//
		SetKey(VK_F4,{||U_AT450F4(oGetD)})
	  
		aObjects := {} 
		aAdd( aObjects, { 315,  70, .T., .t. } )
		aAdd( aObjects, { 100, 100, .t., .t. } )
		aAdd( aObjects, { 100,   7, .t., .f. } )
		aInfo := { aSizeAut[ 1 ], aSizeAut[ 2 ], aSizeAut[ 3 ], aSizeAut[ 4 ], 3, 3 } 
		aPosObj := MsObjSize( aInfo, aObjects ) 
		
		//Ŀ
		//Monta tela de entrada                                                   
		//
		DEFINE MSDIALOG oDlg TITLE CADASTRO FROM aSizeAut[7],0 TO aSizeAut[6],aSizeAut[5] PIXEL 
		
		EnChoice( "AB6" ,nReg,nOpcx,,,,,aPosObj[1],,3,,,,,,.T.)
		oGetD := MsGetDados():New(aPosObj[2,1],aPosObj[2,2],aPosObj[2,3],aPosObj[2,4],nOpcx,"U_AT450LinOk","U_AT450TudOk","+AB7_ITEM",.F.)
		
		nLinIni := aPosObj[ 3, 1 ] 
		
		aPosGet := MsObjGetPos(aSizeAut[3]-aSizeAut[1],310,;
			{{005,065,105,165,205,265}} )
		
		@ nLinIni,aPosGet[1,1] SAY STR0011 SIZE 60,09 OF oDlg PIXEL //"Total: "
		@ nLinIni,aPosGet[1,2] SAY oSay1 VAR Transform(n1, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
		@ nLinIni,aPosGet[1,3] SAY STR0012 SIZE 60,09 OF oDlg PIXEL //"Total do Cliente: "
		@ nLinIni,aPosGet[1,4] SAY oSay2 VAR Transform(n2, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
		@ nLinIni,aPosGet[1,5] SAY STR0013 SIZE 60,09 OF oDlg PIXEL //"Total do Fabricante: "
		@ nLinIni,aPosGet[1,6] SAY oSay3 VAR Transform(n3, cPictureTot) SIZE 40,09 OF oDlg PIXEL 
		oDlg:Cargo := {|n1,n2,n3| 	oSay1:SetText( Transform(n1, cPictureTot) ),;
									oSay2:SetText( Transform(n2, cPictureTot) ),;
									oSay3:SetText( Transform(n3, cPictureTot) ) }
		At450Total(oDlg,.F.)
		ACTIVATE MSDIALOG oDlg ON INIT AT450Bar(oDlg,{||nOpca:=1,oDlg:End()},{||oDlg:End()},nOpcx,oGetD)
		//Ŀ
		// Desabilita a Tecla F4                                        
		//
		SetKey(VK_F4,Nil)
	Else
		If EnchAuto(cAlias,aAutoCab,{|| Obrigatorio(aGets,aTela)}) .And.;
			MsGetDAuto(aAutoItens,"U_AT450LinOk",{|| U_AT450TudOk() },aAutoCab,aRotina[nOpcX][4]) .And. U_At450F4()
			nOpcA := 1
		EndIf
	EndIf
EndIf
If ( nOpcA == 1 )
	//Ŀ
	// Roda o ponto de entrada para verificar se pode excluir       
	//
	If ExistBlock( "U_AT450OKD" )
		lBlockRet := ExecBlock( "U_AT450OKD", .F., .F. ) 
		lGrava    := If( ValType( lBlockRet ) == "L", lBlockRet, lGrava ) 		
    EndIf 
	
	If lGrava
		Begin Transaction     	
			If ( AT450Grava(3)  )
				EvalTrigger()
/*				While ( GetSX8Len() > nSaveSx8 )
					ConfirmSX8()
				EndDo*/
			EndIf
		End Transaction 	
	EndIf 			
EndIf
/*While ( GetSX8Len() > nSaveSx8 )
	RollBackSX8()
EndDo*/

//Ŀ
//Efetua o destravamento dos registros travados.
//
AtDestravaReg( aTravas )

DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])

Return(.T.)

/*/


Ŀ
Funcao    At450Efet  Autor  Vendas Clientes        Data  13.10.98 
Ĵ
Descrio  Efetiva OS                                                 
Ĵ
Retorno    Nenhum                                                     
Ĵ
Parametros ExpC1 = Alias do arquivo                                   
           ExpN1 = Numero do registro                                 
           ExpN2 = Numero da opcao selecionada                        
ٱ


/*/
User Function AT450Efet(cAlias,nReg,nOpc)

Local aSavRot  := aClone(aRotina)		//Backup do array aRotina
Local cQuery   := ""					//Variav. com a query a ser executada
Local cArqInd  := CriaTrab(,.F.)		//Nome do arq. temporario
Local cMarca   := GetMark()				//Indica se a OS esta marcada
Local nIndex   := 0						//Indice do arq. temporario a ser utilizado

aRotina := {   { STR0008 ,"U_At450Visua",0,2},; //"Visual   "
					{ STR0009 ,"U_At450GrvPv",0,4} } //"Pedido   "
//Ŀ
// Parametros                                                             
//                                                                        
// MV_PAR01 - Cliente de                                                  
// MV_PAR02 - Cliente ate                                                 
// MV_PAR03 - Emissao de                                                  
// MV_PAR04 - Emissao ate                                                 
// MV_PAR05 - Chamado de                                                  
// MV_PAR06 - Chamado ate                                                 
// MV_PAR07 - Gera pedidos para situacao		                           
// MV_PAR08 - Qual moeda                                                  
//
If ( Pergunte("ATA450",.T.) )
	If Recmoeda( dDatabase, MV_PAR08 ) <= 0
		//"No existe taxa cadastrada para a moeda selecionada: " # 
		//"Ateno"
		MsgAlert(STR0038 + StrZero(MV_PAR08,1), STR0039) 
		aRotina := aClone(aSavRot)
		Return .F.
	EndIf
	cQuery += "AB6_FILIAL=='"+xFilial("AB6")+"'.And."
	cQuery += "AB6_STATUS<>'E'.And."
	cQuery += "AB6_CODCLI>='"+MV_PAR01+"'.And."
	cQuery += "AB6_CODCLI<='"+MV_PAR02+"'.And."
	cQuery += "Dtos(AB6_EMISSA)>='"+Dtos(MV_PAR03)+"'.And."
	cQuery += "Dtos(AB6_EMISSA)<='"+Dtos(MV_PAR04)+"'.And."
	cQuery += "AB6_NUMOS>='"+MV_PAR05+"'.And."
	cQuery += "AB6_NUMOS<='"+MV_PAR06+"'"//.And."
	//cQuery += "AB6_CONPAG<>'" + Space( Len( AB6->AB6_CONPAG ) ) + "'"
	
	If ExistBlock("U_AT450FIL")
		cQuery := ExecBlock("U_AT450FIL",.F.,.F.,{cQuery})
	EndIf
	
	DbSelectArea("AB6")
	DbSetOrder(1)
	IndRegua("AB6",cArqInd,IndexKey(),,cQuery)
	nIndex := RetIndex("AB6")
	#IFNDEF TOP
		dbSetIndex(cArqInd+OrdBagExt())
	#ENDIF
	DbSetOrder(nIndex+1)
	DbGoTop()
	If ( !Eof() .And. !Bof() )
		MarkBrow("AB6","AB6_OK",,,,cMarca)
	Else
		Help(" ",1,"REGNOIS")
	EndIf
	DbSelectArea("AB6")
	RetIndex("AB6")
	dbClearFilter()
	Ferase(cArqInd+OrdBagExt())
EndIf
//Ŀ
//Retorna as Situacao de Entrada                                          
//
aRotina := aClone(aSavRot)
Return(.T.)

/*/


Ŀ
Funo    AT450MONTA   Autor  Vendas Clientes      Data  03.10.98 
Ĵ
Descrio  Monta aHeader                                              
Ĵ
Sintaxe    Void AT450MONTA(Void)                                      
Ĵ
Parametros                                                            
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450Monta()

Local nUsado   := 0
Local aArea    := { Alias() , IndexOrd() , Recno() }
Local aAreaAB7 := { AB7->(IndexOrd()), AB7->(Recno()) }
Local aAreaAB8 := { AB8->(IndexOrd()), AB8->(Recno()) }
Local aHeader  := {}

//Ŀ
// Monta aHeader do AB7                                         
//
aHeader := {}
DbSelectArea("SX3")
DbSetOrder(1)
DbSeek("AB7")
nUsado := 0
While ( !Eof() .And. SX3->X3_ARQUIVO == "AB7" )
	If ( X3USO(SX3->X3_USADO) .And. cNivel >= SX3->X3_NIVEL )
		aAdd(aHeader,{ AllTrim(X3Titulo()),;
							SX3->X3_CAMPO,;
							SX3->X3_PICTURE,;
							SX3->X3_TAMANHO,;
							SX3->X3_DECIMAL,;
							SX3->X3_VALID,;
							SX3->X3_USADO,;
							SX3->X3_TIPO,;
							SX3->X3_ARQUIVO,;
							SX3->X3_CONTEXT } )
	Endif
	DbSkip()
EndDo

// Inclui coluna de registro atraves de funcao generica
ADHeadRec("AB7", aHeader)

nUsado := Len(aHeader)
aHeaderAB7 := aClone(aHeader)

//Ŀ
// Monta aHeader do AB8                                         
//
aHeader := {}
DbSelectArea("SX3")
DbSetOrder(1)
DbSeek("AB8")
nUsado := 0
While ( !Eof() .And. SX3->X3_ARQUIVO == "AB8" )
	If ( X3USO(SX3->X3_USADO) .And. cNivel >= SX3->X3_NIVEL )
		aAdd(aHeader,{ AllTrim(X3Titulo()),;
							SX3->X3_CAMPO,;
							SX3->X3_PICTURE,;
							SX3->X3_TAMANHO,;
							SX3->X3_DECIMAL,;
							SX3->X3_VALID,;
							SX3->X3_USADO,;
							SX3->X3_TIPO,;
							SX3->X3_ARQUIVO,;
							SX3->X3_CONTEXT } )
	Endif
	DbSkip()
EndDo

// Inclui coluna de registro atraves de funcao generica
ADHeadRec("AB8", aHeader)

nUsado := Len(aHeader)
aHeaderAB8 := aClone(aHeader)

DbSelectArea("AB7")
DbSetOrder(aAreaAB7[1])
DbGoTo(aAreaAB7[2])

DbSelectArea("AB8")
DbSetOrder(aAreaAB8[1])
DbGoTo(aAreaAB8[2])

DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])
Return(.T.)

/*/


Ŀ
Funo    AT450LinOk   Autor  Vendas Clientes      Data  03.10.98 
Ĵ
Descrio  Validacao da Linha na GetDados                             
Ĵ
Sintaxe    Logical AT450LinOk(Void)                                   
Ĵ
Parametros                                                            
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450LinOk(oGet)

Local lRetorno := .T.
Local nUsado   := Len(aHeader)
Local nPosPrd  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_CODPRO"})
Local nPosnSer := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_NUMSER"})
Local nPosPrb  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_CODPRB"})
Local nPosTipo := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_TIPO"})
Local nCntFor  := 0


If ( !aCols[n][nUsado+1] .And. ( Len(aCols) > 1 .Or.!Empty(aCols[n][nPosPrd]) ))
	If (  Empty(aCols[n][nPosPrd]) .Or.;
			Empty(aCols[n][nPosnSer])) //.Or.;
//			Empty(aCols[n][nPosPrb]) )
		lRetorno := .F.
		Help(" ",1,"AT450LIN01")
	EndIf                          
	
	If ( lRetorno )
		For nCntFor := 1 To Len(aCols)
			If (  aCols[n][nPosPrd]+aCols[n][nPosNSer]==;//+aCols[n][nPosPrb]==;
					aCols[nCntFor][nPosPrd]+aCols[nCntFor][nPosNSer] .AND.;//+aCols[nCntFor][nPosPrb] .And.;
					n <> nCntFor .And. !aCols[nCntFor][nUsado+1])
				Help(" ",1,"AT450LIN02")
				lRetorno := .F.
			EndIf
		Next nCntFor
	EndIf
/*	If ( lRetorno )
		DbSelectArea("AA3")
		DbSetOrder(6)
		If ( !DbSeek(xFilial("AA3")+aCols[n][nPosNSer]))//M->AB6_CODCLI+M->AB6_LOJA+aCols[n][nPosPrd]+aCols[n][nPosNSer]) )
			Help(" ",1,"AT450LIN03")
			lRetorno := .F.
		EndIf
	EndIf*/
Else
	If ( aCols[n][nPosTipo] $ "234" )
		Help(" ",1,"AT450LIN04")
		lRetorno := .F.
	EndIf
EndIf

//Ŀ
// Validacao do Usuario                                         
//
If lRetorno 
	If ExistBlock( "U_AT450LOK" ) 
	   lRetorno := ExecBlock( "U_AT450LOK", .F., .F. ) 
	EndIf 	   
EndIf	   

If Type("lAt450Auto")=="U" .Or. !lAt450Auto
	At450Total(oGet:oWnd,.F.)
EndIf  

Return(lRetorno)

/*/


Ŀ
Funo    AT450TudOk   Autor  Vendas Clientes      Data  03.10.98 
Ĵ
Descrio  Validacao da GetDados                                      
Ĵ
Sintaxe    Logical AT450TudOk(Void)                                   
Ĵ
Parametros                                                            
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450TudOk()

Local lRetorno := .T.
Local nPosPrd  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_CODPRO"})
Local nPosnSer := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_NUMSER"})
Local nCntFor  := 0
Local nPosn61  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_XFLGCP"})
Local nPosn58  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_XFLGOR"})
Local nPosn59  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_XFLGAP"})
Local nPosn60  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_XFLGLI"})
Local nPosPre  := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_FLGPRE"})
Local lRet := .F.

/*For nCntFor := 1 To Len(aCols)
	If ( lRetorno )    
		If !( aCols[ nCntFor, Len( aHeader ) + 1 ] ) 
			DbSelectArea("AA3")
			DbSetOrder(6)
			If ( !DbSeek(xFilial("AA3")+aCols[n][nPosNSer]))//M->AB6_CODCLI+M->AB6_LOJA+aCols[nCntFor][nPosPrd]+aCols[nCntFor][nPosNSer]) )
				Help(" ",1,"AT450TUDOK")
				lRetorno := .F.
			EndIf
		EndIf 			
	EndIf
Next nCntFor       */

//Ŀ
// Validacao do Usuario                                         
//
If lRetorno 
	If ExistBlock( "U_AT450TOK" ) 
		lRetorno := ExecBlock( "U_AT450TOK", .F., .F. ) 
	EndIf 
EndIf   

For nCntFor := 1 to Len(aCols)

	U_GTSTATUS(nCntFor)  
	
	U_GTSTAPRE(nCntFor)                        
	
	U_GTORRET(nCntFor)
	
	U_GTOCDRET(nCntFor)             
	
	U_GTAPRET(nCntFor)

Next                          

For nCntFor := 1 to Len(aCols)
	
	If Empty(aCols[nCntFor,nPosPre])
		lRet := U_VALFRETE(nCntFor)
	ElseIf Empty(aCols[nCntFor,nPosn61])
		lRet := U_GTAPROV(nCntFor)// Valida Aprovao
	ElseIf Empty(aCols[nCntFor,nPosn58])
		lRet := U_GTORCA(nCntFor)//Valida Orcamento
	ElseIf Empty(aCols[nCntFor,nPosn59])
		lRet := U_GTAPROVACAO(nCntFor)//Valida Aprovao
	ElseIf Empty(aCols[nCntFor,nPosn60])
		lRet := U_GTLIBERA(nCntFor) //Valida Liberao
	EndIf
	
	If lRet
		exit
	EndIf
		
	
Next

Return(lRetorno)

/*/


Ŀ
Funcao    At450GrvPV Autor  Vendas Clientes        Data  02.10.98 
Ĵ
Descrio  Gera a Pedido de Venda                                     
Ĵ
Retorno    Void                                                       
Ĵ
Parametros Void                                                       
                                                                      
ٱ


/*/
User Function AT450GrvPV()

Processa({|| At450Proc() })
CloseBrowse()
Return(.T.)

/*/


Ŀ
Funcao    At450Proc  Autor  Vendas Clientes        Data  02.10.98 
Ĵ
Descrio  Processamento da Efetivacao do Pedido de Venda             
Ĵ
Retorno    Void                                                       
Ĵ
Parametros                                                            
ٱ


/*/
Static Function AT450Proc()

Local nCntFor        := 0
Local lTravas        := .T.
Local aTravas        := {}
Local nUsado         := 0
Local nPosItem       := 0
Local nPosTipo       := 0
Local aAux           := {}

Local lGrava         := .T.
Local lAt450OKE      := ExistBlock( "U_AT450OKE", .F., .F. ) 
Local bFiltroPV      := { || .T. } 
//Local nSaveSX8			:= GetSX8Len()

Private aHeader		:= {}
Private aHeaderAB8	:= {}
Private aHeaderAB7	:= {}
Private aCols		:= {}
Private aColsAB8	:= {}

Do Case 
Case MV_PAR07 == 1   
	//Ŀ
	// Todos                                                        
	//
	bFiltroPV := { || .T. } 
Case MV_PAR07 == 2
	//Ŀ
	// Atendidos                                                    
	//
	bFiltroPV := { || AB7->AB7_TIPO == "4" }
Case MV_PAR07 == 3
	//Ŀ
	// Em atendimento                                               
	//
	bFiltroPV := { || AB7->AB7_TIPO == "3" }
Case MV_PAR07 == 4	
	//Ŀ
	// O.S.                                                         
	//
	bFiltroPV := { || AB7->AB7_TIPO == "1" }	
EndCase

//Ŀ
// Monta aHeader                                                
//
U_AT450Monta()
aHeader  := aClone(aHeaderAB7)
nUsado   := Len(aHeader)
nPosItem := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_ITEM"})
nPosTipo := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_TIPO"})

//Ŀ
//Processamento da MarkBrowse                                             
//
DbSelectArea("AB6")
DbGoTop() //IndRegua()
ProcRegua(LastRec())
While ( !Eof() )
	If ( IsMark("AB6_OK",ThisMark(),ThisInv()) .AND. SoftLock("AB6")) .AND. U_At450MoedaOK()
	
    	//Ŀ
		// Roda o ponto de entrada para verificar se pode efetivar      	
		//
		If lAT450OKE
			lBlockRet := ExecBlock( "AT450OKE", .F., .F. ) 
			lGrava    := If( ValType( lBlockRet ) == "L", lBlockRet, lGrava ) 		
		EndIf               

		If lGrava 				
	
			aTravas := {}
			aCols   := {}
			aColsAb8:= {}
			aAux    := {}
			aHeader  := aClone(aHeaderAB7)
			lTravas := .T.
			//Ŀ
			// Cria Variaveis de Memoria da Enchoice                
			//
			DbSelectArea("AB6")
			aAdd(aTravas , { Alias() , RecNo() })
			For nCntFor := 1 To FCount()
				uCampo := FieldName(nCntFor)
				M->&(uCampo) := AB6->(FieldGet(FieldPos(uCampo)))
			Next nCntFor
			//Ŀ
			// Monta aCols                                                  
			//
			DbSelectArea("AB7")
			DbSetOrder(1)
			DbSeek(xFilial("AB7")+AB6->AB6_NUMOS)
			While ( !Eof() .And. xFilial("AB7")    == AB7->AB7_FILIAL .And.;
											AB6->AB6_NUMOS == AB7->AB7_NUMOS )
				If ( SoftLock("AB7") )
					aAdd(aTravas, { Alias() , RecNo() })
				Else
					lTravas := .F.
				EndIf
				aAdd(aCols,Array(nUsado+1))
				For nCntFor := 1 To nUsado
					If IsHeadRec(aHeader[nCntFor][2])
						aCols[Len(aCols)][nCntFor] := AB7->(RecNo())
					Elseif IsHeadAlias(aHeader[nCntFor][2])
						aCols[Len(aCols)][nCntFor] := "AB7"
					Elseif ( aHeader[nCntFor][10] <> "V" )
						aCols[Len(aCols)][nCntFor] := FieldGet(FieldPos(aHeader[nCntFor][2]))
					Else
						aCols[Len(aCols)][nCntFor] := CriaVar(aHeader[nCntFor][2])
					EndIf
				Next nCntFor
				aCols[Len(aCols)][nUsado+1] := .F.
				aAux := {}
				DbSelectArea("AB8")
				DbSetOrder(1)
				If ( DbSeek(xFilial("AB8")+AB6->AB6_NUMOS+AB7->AB7_ITEM) )           
				
					//Ŀ
					// Filtra a geracao do pedido                                   
					//
					If Eval( bFiltroPV ) 
						aCols[Len(aCols)][nPosTipo] := "2"
					EndIf 		
					
					While ( !Eof() .And. xFilial("AB8") == AB8->AB8_FILIAL .And.;
												AB6->AB6_NUMOS == AB8->AB8_NUMOS .And.;
												AB7->AB7_ITEM== AB8->AB8_ITEM )
						If ( SoftLock("AB8") )
							aAdd(aTravas, { Alias() , RecNo() })
						Else
							lTravas := .F.
						EndIf
						aAdd(aAux,Array(Len(aHeaderAB8)+1))
						For nCntFor := 1 To Len(aHeaderAB8)
							If IsHeadRec(aHeaderAB8[nCntFor][2])
								aAux[Len(aAux)][nCntFor] := AB8->(RecNo())
							Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
								aAux[Len(aAux)][nCntFor] := "AB8"
							Elseif ( aHeaderAB8[nCntFor][10] <> "V" )
								aAux[Len(aAux)][nCntFor] := FieldGet(FieldPos(aHeaderAB8[nCntFor][2]))
							Else
								aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
							EndIf
						Next nCntFor
						aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
						DbSelectArea("AB8")
						DbSkip()
					EndDo
					aAdd(aColsAB8,aClone(aAux))
				Else
					aAdd(aAux,Array(Len(aHeaderAB8)+1))
					For nCntFor := 1 To Len(aHeaderAB8)
						If IsHeadRec(aHeaderAB8[nCntFor][2])
							aAux[Len(aAux)][nCntFor] := 0
						Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
							aAux[Len(aAux)][nCntFor] := "AB8"
						Else
							aAux[Len(aAux)][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2])
						Endif
					Next nCntFor
					aAux[Len(aAux)][nPosItem] := "01"
					aAux[Len(aAux)][Len(aHeaderAB8)+1] := .F.
					aAdd(aColsAB8,aClone(aAux))
				EndIf
				DbSelectArea("AB7")
				DbSkip()
			EndDo
			Begin Transaction
				If ( AT450Grava(2)  )
					EvalTrigger()
/*					While ( GetSX8Len() > nSaveSx8 )
						ConfirmSX8()
					EndDo*/
				EndIf
			End Transaction
			For nCntFor := 1 To Len(aTravas)
				DbSelectArea(aTravas[nCntFor][1])
				DbGoTo(aTravas[nCntFor][2])
				MsUnLock()
			Next nCntFor
		EndIf 			
	EndIf
	DbSelectArea("AB6")
	DbSkip()
	IncProc()
EndDo
Return(.T.)

/*/


Ŀ
Funo    AT450F4      Autor  Vendas Clientes      Data  03.10.98 
Ĵ
Descrio  Tratamento da tecla F4.                                    
Ĵ
Sintaxe    Void AT450F4(Void)                                         
Ĵ
Parametros a,b,c                                                      
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450F4(oGetD)

Local oDlg			:= Nil
Local oGetF4		:= Nil
Local oSay1			:= Nil
Local oSay2			:= Nil
Local oSay3			:= Nil
Local nOpcA    := 0
Local aArea    := { Alias(), IndexOrd() , Recno() }
Local aSavAcols:= {}
Local nSavN    := If(Type("N")=="U",1,N)
Local aAux     := {}
Local bSetKey		:= Nil
Local cCadastro:= STR0010 //"Apontamento(s)"
Local nCntFor  := 0
Local nUsado   := Len(aHeaderAB8)
Local nPosItem := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_SUBITE"})
Local nPosPrd  := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_CODPRO"})
Local nPosNSer := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_NUMSER"})
Local lRetorno := .T.


Local nItAcols := If(Type("N")=="U",1,N)
Local cProduto := cNumSer := ""
     
Private aColsMain	:= Nil 
Private nMain		:= Nil

aSavAcols   := aClone(aCols)
aColsMain   := aClone(aCols) 
nMain       := nSavN
cProduto    := aSavaCols[nItAcols][nPosPrd]
cNumSer     := aSavaCols[nItAcols][nPosNSer]

//Ŀ
// Posiciona a tabela de Base Instalada 
//
/*AA3->( DbSetOrder( 6 ) ) 
AA3->( DbSeek( xFilial( "AA3" ) + cNumSer ) )/*M->AB6_CODCLI + M->AB6_LOJA + ;
       cProduto + cNumSer ) )*/

aHeader     := aClone(aHeaderAB8)
If ( Empty(aColsAB8) .Or. Len(aColsAB8)<=nItAcols )
	aAdd(aAux,Array(nUsado+1))
	For nCntFor := 1 To nUsado
		If IsHeadRec(aHeaderAB8[nCntFor][2])
			aAux[1][nCntFor] := 0
		Elseif IsHeadAlias(aHeaderAB8[nCntFor][2])
			aAux[1][nCntFor] := "AB8"
		Else	
			aAux[1][nCntFor] := CriaVar(aHeaderAB8[nCntFor][2],.T.)
		Endif
	Next nCntFor
	aAux[1][nUsado+1] := .F.
	aAux[1][nPosItem] := "01"
	For nCntFor := Len(aColsAB8)+1 To ( nItAcols )
		aAdd(aColsAB8,aClone(aAux))
	Next nCntFor
EndIf
aCols := aColsAB8[nItAcols]
//Ŀ
//Posiciona Registros                                                     
//
DbSelectArea("SA1")
DbSetOrder(1)
DbSeek(xFilial("SA1")+M->AB6_CODCLI+M->AB6_LOJA)
    
//
// Atualiza picture 
//
cPictureTot	:= PesqPict("AB8","AB8_TOTAL",14,M->AB6_MOEDA) 

If Type("lAt450Auto")=="U" .Or. !lAt450Auto
	bSetKey  := SetKey(VK_F4,)
	SetKey(VK_F4,Nil)
	//Ŀ
	//Salva o aCols   de Entrada e Desabilita o Paint da Primeira GetDados    
	//
	oGetD:oBrowse:lDisablePaint := .T.

	//Ŀ
	//Monta a GetDados                                                        
	//
	DEFINE MSDIALOG oDlg TITLE cCadastro From 10,0 to 28,80
	@ 001,01 SAY RetTitle("AB6_CODCLI")+" "+M->AB6_CODCLI+"-"+M->AB6_LOJA+"/"+SA1->A1_NOME
	@ 002,01 SAY RetTitle("AB7_CODPRO")+" "+cProduto+RetTitle("AB7_NUMSER")+" "+cNumSer
	oGetF4 := MsGetDados():New(035,001,125,316,nOpcF4,"U_AT450F4LOk","AllwaysTrue","+AB8_SUBITE",.T.,,,,NUMITENS )
	@ 128,005 SAY STR0011 SIZE 60,09 OF oDlg PIXEL //"Total: "
	@ 128,065 SAY oSay1 PROMPT 0 PICTURE cPictureTot SIZE 40,09 OF oDlg PIXEL 
	@ 128,105 SAY STR0012 SIZE 60,09 OF oDlg PIXEL //"Total do Cliente: "
	@ 128,165 SAY oSay2 PROMPT 0 PICTURE cPictureTot SIZE 40,09 OF oDlg PIXEL 
	@ 128,205 SAY STR0013 SIZE 60,09 OF oDlg PIXEL //"Total do Fabricante: "
	@ 128,265 SAY oSay3 PROMPT 0 PICTURE cPictureTot SIZE 40,09 OF oDlg PIXEL 
	oDlg:Cargo := {|n1,n2,n3| 	oSay1:SetText(n1),;
								oSay2:SetText(n2),;
								oSay3:SetText(n3) }
	At450Total(oDlg,.T.)
	ACTIVATE MSDIALOG oDlg ON INIT EnchoiceBar(oDlg,{||nOpca:=1,if(oGetF4:TudoOk(),oDlg:End(),nOpca:=0)},{||oDlg:End()})
	//Ŀ
	//Volta a situacao anterior                                               
	//
	SetKey(VK_F4,Nil)
	SetKey(VK_F4,bSetKey)
	If ( nOpcA == 1 )
		aColsAB8[nItAcols] := aClone(aCols)
		At450Total(oGetD:oWnd,.F.)
	EndIf
	oGetD:oBrowse:lDisablePaint := .F.
Else
	If MsGetDAuto(aAutoApont,"U_AT450F4LOk",{|| .T. },aAutoCab,aRotina[nOpcF4][4])
		aColsAB8[nItAcols] := aClone(aCols)
	Else
		lRetorno := .F.
	EndIf
EndIf

aHeader   := aClone(aHeaderAB7)
aCols     := aClone(aSavACols)
aColsMain := NIL 
n := nSavN
DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])
Return lRetorno

/*/


Ŀ
Funo    AT450F4LOk   Autor  Vendas Clientes      Data  03.10.98 
Ĵ
Descrio  Validacao da Linha na GetDados 2                           
Ĵ
Sintaxe    Logical AT450F4LOk(Void)                                   
Ĵ
Parametros ExpO1: Objeto do MsGetDados                                
Ĵ
Retorno    ExpL1: Se .T. permite a troca de linha, .F. no permite    
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450F4LOk(oGet)

Local lRetorno := .T.													// Retorno da funo
Local nUsado   := Len(aHeaderAB8)										// Campos utilizados
Local nPosPrd  := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_CODPRO"})	// Posio no aHeaderAB8 do campo Produto
Local nPosTipo := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_CODSER"})	// Posio no aHeaderAB8 do campo Servio
Local nPosQtd  := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_QUANT"})	// Posio no aHeaderAB8 do campo Quantidade
Local nPosUnit := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_VUNIT"})	// Posio no aHeaderAB8 do campo Valor Unitrio
Local nPosLista:= aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_PRCLIS"})	// Posio no aHeaderAB8 do campo Preo de Lista
Local nPosVlr  := aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_TOTAL"})	// Posio no aHeaderAB8 do campo Valor Total 
Local nPosLocal:= aScan(aHeaderAB8,{|x| AllTrim(x[2])=="AB8_LOCAL"})	// Posio no aHeaderAB8 do campo Endereo
Local lAT450VLD:= ExistBlock( "U_AT450VLD" )								// Se existe ou no o P.E. AT450VLD

If ( !aCols[n][nUsado+1] )
	If (  Empty(aCols[n][nPosPrd]) .Or.;
			Empty(aCols[n][nPosTipo]) .Or.;
			Empty(aCols[n][nPosQtd]) .Or.;
			Empty(aCols[n][nPosUnit]) .Or.;
			Empty(aCols[n][nPosLista]) .Or.;
			Empty(aCols[n][nPosVlr]) .Or.;
			Empty(aCols[n][nPosLocal]) ) ;
			.And. ( Len(aCols) > 1 .Or. !Empty(aCols[n][nPosPrd]))
		lRetorno := .F.
		Help(" ",1,"AT450F4L01")
	EndIf                                                  
	
	//Ŀ
	//Valida o Total conferindo o arredondamento que eh o
	//mesmo utilizado na gravacao do campo AB8_TOTAL     
	//
	If ( Round( aCols[n][nPosQtd]*aCols[n][nPosUnit] ,2) <> Round(aCols[n][nPosVlr] ,2) )
		Help(" ",1,"AT450F4L02")
		lRetorno := .F.
	EndIf
	If ( lRetorno )
		DbSelectArea("AA5")
		DbSetOrder(1)
		DbSeek(xFilial("AA5")+aCols[n][nPosTipo])
		DbSelectArea("SF4")
		DbSetOrder(1)
		DbSeek(xFilial("SF4")+AA5->AA5_TES)
		DbSelectArea("SB2")
		DbSetOrder(1)
		If (!DbSeek(xFilial("SB2")+aCols[n][nPosPrd]+aCols[n][nPosLocal]) .And. SF4->F4_ESTOQUE=="S" )
			Help(" ",1,"AT450F4L03")
		EndIf
	EndIf
EndIf

If Type("lAt450Auto")=="U" .Or. !lAt450Auto
	At450Total(oGet:oWnd,.T.)
EndIf

If lRetorno .AND. lAT450VLD
	If !ExecBlock( "AT450VLD", .F., .F. )
		lRetorno := .F.
	EndIf
EndIf

Return(lRetorno)

/*/


Ŀ
Funo    AT450Eqpto Autor  Vendas Clientes        Data  29.09.98 
Ĵ
Descrio  Valida a amarracao Produto X Equipamento                   
Ĵ
Sintaxe    Void AT450Eqpto()                                          
Ĵ
 Uso       TECA450                                                    
ٱ


/*/
User Function AT450Eqpto()

Local lRetorno    := .F.
Local cCampo      := ReadVar()
Local uConteudo   := &(ReadVar())
Local nPosProd    := aScan(aHeader,{|x| AllTrim(x[2])=="AB7_CODPRO" })
Local aArea       := { Alias() , IndexOrd() , RecNo() }

/*Do Case
	Case ( "AB7_CODPRO"$cCampo )
//		DbSelectArea("AA3")
//		DbSetOrder(1)
		DbSetOrder(6)
		If ( DbSeek(xFilial("AA3")+aCols[n][nPosNSer]))//M->AB6_CODCLI+M->AB6_LOJA+uConteudo) )
			lRetorno := .T.
		Else
			Help(" ",1,"REGNOIS")
		EndIf
	Case ( "AB7_NUMSER"$cCampo )
		DbSelectArea("AA3")
		DbSetOrder(6)
		If ( DbSeek(xFilial("AA3")+aCols[n][nPosNSer]))//M->AB6_CODCLI+M->AB6_LOJA+aCols[n][nPosProd]+uConteudo) )
			lRetorno := .T.
		Else
			Help(" ",1,"REGNOIS")
		EndIf
EndCase*/

DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])
Return(lRetorno)

/*

Ŀ
Funo    AT450Bar   Autor  Vendas Clientes        Data  21.09.98  
Ĵ
Descrio  Mostra a EnchoiceBar na tela                                
Ĵ
 Uso       TECA450                                                     
ٱ


*/
Static Function AT450Bar(oDlg,bOk,bCancel,nOpc,oGetD)
Local aButtons   := {}
Local aUsButtons := {} 
Local lTECA450 := AtIsRotina("ATC010CON").Or.AtIsRotina("ATC020CON")

If ( nOpc <> 5 )
	aAdd(aButtons,{"S4SB014N" , {|| At450Aloc(oGetD)} , STR0025, STR0028 }) //"Programao da OS"
	aAdd(aButtons,{"RELATORIO", {|| U_At450Laudo(oGetD)}, STR0026, STR0029 }) //"Atendimento da OS"
	aAdd(aButtons,{"PRODUTO"  , {|| AT450F4(oGetD)   }, STR0021, STR0030 }) //"Apontamento..."
EndIf            

If nOpc == 2 .And. !AtIsRotina("AT450TRACK") 	
	aAdd(aButtons,{"bmpord1",{|| At450Track()}, STR0027, STR0031 }) // "System Tracker"
EndIf 	

If !lTECA450
	aAdd(aButtons,{"IMPRESSAO", {|| TECR450(M->AB6_NUMOS)}, STR0022, STR0032}) //"Impressao da OS gravada"
EndIf   
 
//Ŀ
// Adiciona botoes do usuario na EnchoiceBar                              
//

If ExistBlock( "U_AT450BUT" ) 
	aUsButtons := ExecBlock( "U_AT450BUT", .F., .F. ) 
	aEval( aUsButtons, { |x| aAdd( aButtons, x ) } ) 	 	
EndIf 	

Return (EnchoiceBar(oDlg,bOK,bcancel,,aButtons))

/*


Ŀ
Funo    AT450Tab     Autor  Vendas Clientes      Data  25/06/01 
Ĵ
Descrio  Funcao de Calculo do Preco de Tabela                       
Ĵ
Sintaxe    ExpN1 := AT450Tab(ExpC1,ExpC2,ExpN2,ExpC3,ExpC4)           
Ĵ
Parametros ExpC1 -> Produto                                            
           ExpC2 -> Tabela de preco                                   
           ExpN2 -> Quantidade                                        
           ExpC3 -> Cliente                                           
           ExpC4 -> Loja do Cliente                                   
Ĵ
Retorno    ExpN1 := Preco de tabela                                   
Ĵ
 Uso       MATA415                                                    
ٱ


*/ 
User Function AT450Tab(	cProduto,	cTabprec,	nQtde,	cCliente,;
					cLoja	,	nMoeda)

Local aArea   := GetArea() 
Local nPrcVen := 0 

DbSelectArea("SB1")
DbSetOrder(1)
If ( !Empty(cProduto) .And. DbSeek(xFilial("SB1")+cProduto,.F.) )
	nPrcVen := MaTabPrVen(cTabPrec,cProduto,nQtde,cCliente,cLoja,nMoeda)
EndIf

RestArea( aArea ) 

Return (nPrcVen)

/*/


Ŀ
Funcao    aT450Desc  Autor  Vendas Clientes        Data  10.07.98 
Ĵ
Descrio  Calcula o Preco com Desconto                               
Ĵ
Retorno    Preco com Desconto em cascata                              
Ĵ
Parametros Nenhum                                                     
                                                                      
ٱ


/*/
User Function AT450Desc()

Local nPPrcLis    := aScan(aHeader,{|x| AllTrim(x[2])=="AB8_PRCLIS"})
Local nPPrcVen    := aScan(aHeader,{|x| AllTrim(x[2])=="AB8_VUNIT"})
Local nPrcVen     := 0

nPrcVen := aCols[n][nPPrcLis]
If ( M->AB6_DESC1 > 0 )
	nPrcVen *= (( 100 - M->AB6_DESC1 )/100)
EndIf
If ( M->AB6_DESC2 > 0 )
	nPrcVen *= (( 100 - M->AB6_DESC2 )/100)
EndIf
If ( M->AB6_DESC3 > 0 )
	nPrcVen *= (( 100 - M->AB6_DESC3 )/100)
EndIf
If ( M->AB6_DESC4 > 0 )
	nPrcVen *= (( 100 - M->AB6_DESC4 )/100)
EndIf
nPrcVen := NoRound(nPrcVen,TamSx3("AB8_VUNIT")[2])
If ( nPrcVen == 0 )
	nPrcVen := aCols[n][nPPrcVen]
EndIf
Return(nPrcVen)

/*/


Ŀ
Funcao    At450RDesc Autor  Vendas Clientes        Data  10.07.98 
Ĵ
Descrio  Recalcula os descontos em cascata                          
Ĵ
Retorno    .t.                                                        
Ĵ
Parametros                                                            
                                                                      
ٱ


/*/
User Function AT450RDesc()

Local nCtnFor  := 0
Local nCntFor2 := 0
Local nPPrcLis := aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_PRCLIS"})
Local nPVunit  := aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_VUNIT"})
Local nPTotal  := aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_TOTAL"})
Local nPQuant  := aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_QUANT"})
Local nPrcVen  := 0
Local nCntFor  := 0

For nCntFor := 1 To Len(aColsAB8)
	For nCntFor2 := 1 To Len(aColsAB8[nCntFor])
		If ( M->AB6_DESC1 > 0 .Or.;
				M->AB6_DESC2 > 0 .Or.;
				M->AB6_DESC3 > 0 .Or.;
				M->AB6_DESC4 > 0 )
			nPrcVen := aColsAB8[nCntFor][nCntFor2][nPPrcLis]
		EndIf
		If ( M->AB6_DESC1 > 0 )
			nPrcVen *= (( 100 - M->AB6_DESC1 )/100)
		EndIf
		If ( M->AB6_DESC2 > 0 )
			nPrcVen *= (( 100 - M->AB6_DESC2 )/100)
		EndIf
		If ( M->AB6_DESC3 > 0 )
			nPrcVen *= (( 100 - M->AB6_DESC3 )/100)
		EndIf
		If ( M->AB6_DESC4 > 0 )
			nPrcVen *= (( 100 - M->AB6_DESC4 )/100)
		EndIf
		nPrcVen := NoRound(nPrcVen,TamSx3("AB8_VUNIT")[2])
		If ( nPrcVen <> 0 )
			aColsAB8[nCntFor][nCntFor2][nPVunit] := nPrcVen
			aColsAB8[nCntFor][nCntFor2][nPTotal] := aColsAB8[nCntFor][nCntFor2][nPQuant]*aColsAB8[nCntFor][nCntFor2][nPVunit]
		Endif
	Next nCntFor2
Next nCntFor2
Return(.T.)


/*/


Ŀ
Funcao    At450Tipo  Autor  Vendas Clientes        Data  13.10.98 
Ĵ
Descrio  Valida o Tipo da OS                                        
Ĵ
Retorno    Logico                                                     
Ĵ
Parametros Nenhum                                                     
                                                                      
ٱ


/*/
User Function AT450Tipo()

Local lRetorno := .T.
Local nPosItem := aScan(aHeaderAB7,{|x| AllTrim(x[2])=="AB7_ITEM"})
Local cTipo    := &(ReadVar())

DbSelectArea("AB7")
DbSetOrder(1)
If ( DbSeek(xFilial("AB7")+M->AB6_NUMOS+aCols[n][nPosItem]) )
	If ( AB7->AB7_TIPO $ "234" .And. cTipo <> "2" )
		Help(" ",1,"AT450LIN04")
		lRetorno := .F.
	EndIf
EndIf
Return(lRetorno)

/*/


Ŀ
Funcao    At450Total Autor  Vendas Clientes        Data  07.01.98 
Ĵ
Descrio Totalizacao da Janela                                       
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosoDlg    : Objeto da Janela                                  
          nItem   : Item da Getdados Principal                        
ٱ


/*/
Static Function AT450Total(oDlg,lF4)

Local nUsado	:= Len(aHeaderAb8)
Local nCntFor	:= 0
Local nCntFor2	:= 0
Local nPosProd := aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_CODPRO"})
Local nPosTotal:= aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_TOTAL"})
Local nPosSer	:= aScan(aHeaderAb8,{|x| AllTrim(x[2])=="AB8_CODSER"})
Local nTotGer	:= 0
Local nTotCli	:= 0
Local nTotFab	:= 0

If ( lF4 )
	For nCntFor := 1 To Len(aCols)
		If ( Len(aCols[nCntFor])==nUsado .Or. !aCols[nCntFor][nUsado+1] )
			nTotCli	+= AtVlrPagto(aCols[nCntFor][nPosSer],aCols[nCntFor][nPosTotal],"C")
			nTotFab	+= AtVlrPagto(aCols[nCntFor][nPosSer],aCols[nCntFor][nPosTotal],"F")
			nTotGer  += aCols[nCntFor][nPosTotal]
		EndIf
	Next nCntFor
Else
	For nCntFor := 1 To Len(aColsAB8)
		For nCntFor2 := 1 To Len(aColsAB8[nCntFor])
			If ( Len(aColsAB8[nCntFor][nCntFor2])==nUsado .Or. !aColsAB8[nCntFor][nCntFor2][nUsado+1] )
				nTotCli	+= AtVlrPagto(aColsAB8[nCntFor][nCntFor2][nPosSer],aColsAB8[nCntFor][nCntFor2][nPosTotal],"C")
				nTotFab	+= AtVlrPagto(aColsAB8[nCntFor][nCntFor2][nPosSer],aColsAB8[nCntFor][nCntFor2][nPosTotal],"F")
				nTotGer  += aColsAB8[nCntFor][nCntFor2][nPosTotal]
			EndIf
		Next nCntFor2
	Next nCntFor
EndIf
Eval(oDlg:Cargo,nTotGer,nTotCli,nTotFab)
Return(.T.)

/*/


Ŀ
Funcao    At450Aloc  Autor  Vendas Clientes        Data 28.01.99  
Ĵ
Descrio  Demonstra as alocacoes da Ordem de Servico.                
Ĵ
Retorno                                                               
Ĵ
ParametrosoGetd : Objeto da Getdados                                  
                                                                      
ٱ


/*/
Static Function AT450Aloc(oGetd)

Local aArea		:= GetArea()
Local oDlg		:= Nil
Local oGetd2	:= Nil
Local cCadastro	:= STR0025		//"Programao da OS"
Local aSavCols	:= aClone(aCols)
Local aSavHead	:= aClone(aHeader)
Local nSavN		:= If(Type("N")=="U",1,N)
Local cSeek		:= ""			// Seek para montagem da aCols
Local cWhile	:= ""			// While para montagem da aHeader

Private aCols	:= {}
Private aHeader	:= {}
Private INCLUI	:= .F.
Private ALTERA	:= .F.
Private dData	:= dDataBase

oGetD:oBrowse:lDisablePaint:= .T.

DbSelectArea("SA1")
DbSetOrder(1)
DbSeek(xFilial("SA1")+M->AB6_CODCLI+M->AB6_LOJA)

//Ŀ
//Montagem aHeader, aCols
//
cSeek	:= xFilial("ABB")+M->AB6_NUMOS
cWhile	:= "ABB->ABB_FILIAL+M->AB6_NUMOS"

FillGetDados(	2   			,"ABB"			,3				,cSeek				,;
  				{|| &cWhile }	,{|| .T. }		,/*aNoFields*/	,/*aYesFields*/		,; 
				/*lOnlyYes*/	,/*cQuery*/		,/*bMontCols*/	,/*lEmpty*/			,;
				/*aHeaderAux*/	,/*aColsAux*/	,/*bAfterCols*/	,/*bBeforeCols*/	)

//Ŀ
// Se a 1a. linha estiver em branco, limpa o aCols 
//
If Len(aCols) > 0 .AND. Empty( aCols[1][GdFieldPos("ABB_NUMOS")] )
	aCols := {}
EndIf	

If ( Len(aCols) <> 0 )
	DEFINE MSDIALOG oDlg TITLE cCadastro FROM 09,0 TO 28,80 OF oMainWnd
	@ 015,010 SAY   RetTitle("AB6_CODCLI") 	SIZE 040,009 	OF oDlg PIXEL
	@ 015,050 MSGET SA1->A1_NOME					SIZE 136,009 	OF oDlg PIXEL WHEN .F.
	oGetd2:=MsGetDados():New(030,005,138,314,1,"","","",.F.)
	ACTIVATE MSDIALOG oDlg ON INIT EnchoiceBar(oDlg,{||oDlg:End()},{||oDlg:End()})
Else
	Help(" ",1,"AT450NALO") //Hedit2
EndIf

//Ŀ
//Restaura a entrada da rotina                                            
//
aCols 	:= aClone(aSavCols)
aHeader	:= aClone(aSavHead)
N		:= nSavN
oGetD:oBrowse:lDisablePaint:= .F.

RestArea(aArea)

Return(Nil)


/*/


Ŀ
Funcao    At450Laudo Autor  Vendas Clientes        Data 29.01.99  
Ĵ
Descrio Demonstrativo dos Laudo Tecnicos                            
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosNenhum                                                      
                                                                      
ٱ


/*/
User Function AT450Laudo(oGetD, cEtapa )

Local aArea	    := GetArea()					//Guarda a area atual
Local nCntFor   := 0							//Usada em lacos For...Next                                               
Local nUsado    := 0							//Nr. de campos no aHeader
Local oDlg		:= Nil							//Obj. Dialog Principal
Local oGetd2	:= Nil							//Obj. GetDados2

Local cCadastro := STR0026 						//"Atendimento da OS"
Local cTarefa   := ""							//Cod. da tarefa
Local cDescTrf  := ""							//Descr. da tarefa
Local cSeekAB9  := ""							//Seek no arquivo AB9
Local cSeek		:= ""							//Seek para montagem da aCols
Local cWhile	:= ""							//While para montagem da aCols
Local aSavCols	:= aClone(aCols)				//Copia do aCols
Local aSavHead	:= aClone(aHeader)				//Copia do aHeader
Local nSavN		:= If(Type("N")=="U",1,N)		//Copia de N
Local nOrdem	:= 0							//Indice para FillGetDados

lTarefa := ( ValType( cEtapa ) == "C" ) 

If lTarefa
	cTarefa  := cEtapa + GDFieldGet( "ABJ_SUBITE" ) 
	cDescTrf := GDFieldGet( "ABJ_DESCRI" ) 
EndIf   

Private aCols	:= {}
Private aHeader	:= {}
Private INCLUI	:= .F.
Private ALTERA  := .F.
Private dData	:= dDataBase

oGetD:oBrowse:lDisablePaint:= .T.

If !lTarefa
	DbSelectArea("SA1")
	DbSetOrder(1)
	DbSeek(xFilial("SA1")+M->AB6_CODCLI+M->AB6_LOJA)
EndIf 	

If lTarefa 
	cSeek	:= xFilial("AB9") + cTarefa
	cWhile	:= "AB9->AB9_FILIAL + AB9->AB9_TAREFA"
	nOrdem	:= 4
Else                         	
	cSeek	:= xFilial("AB9") + M->AB6_NUMOS
	cWhile	:= "AB9->AB9_FILIAL + SubStr(AB9->AB9_NUMOS,1,Len(M->AB6_NUMOS))"	
	nOrdem	:= 1
EndIf 	

//Ŀ
//Montagem aHeader, aCols
//
FillGetDados(	2   			,"AB9"			,nOrdem			,cSeek				,;
  				{|| &cWhile }	,{|| .T. }		,/*aNoFields*/	,/*aYesFields*/		,; 
				/*lOnlyYes*/	,/*cQuery*/		,/*bMontCols*/	,/*lEmpty*/			,;
				/*aHeaderAux*/	,/*aColsAux*/	,/*bAfterCols*/	,/*bBeforeCols*/	)

//Ŀ
// Se a 1a. linha estiver em branco, limpa o aCols 
//
If Len(aCols) > 0 .AND. Empty( aCols[1][GdFieldPos("AB9_NUMOS")] )
	aCols := {}
EndIf

If ( Len(aCols) <> 0 )
	DEFINE MSDIALOG oDlg TITLE cCadastro FROM 09,0 TO 28,80 OF oMainWnd
	
	If lTarefa 
		@ 015,010 SAY   RetTitle("ABJ_TAREFA") 	SIZE 040,009 	OF oDlg PIXEL
		@ 015,050 MSGET cDescTrf     			SIZE 136,009 	OF oDlg PIXEL WHEN .F.
	Else 		
		@ 015,010 SAY   RetTitle("AB6_CODCLI") 	SIZE 040,009 	OF oDlg PIXEL
		@ 015,050 MSGET SA1->A1_NOME			SIZE 136,009 	OF oDlg PIXEL WHEN .F.
	EndIf 	
		
	oGetd2:=MsGetDados():New(030,005,138,314,1,"","","",.F.)
	ACTIVATE MSDIALOG oDlg ON INIT At450Bar2(oDlg,{||oDlg:End()},{||oDlg:End()},,oGetD2)
Else
	Help(" ",1,"AT450LAUDO") //Hedit2
EndIf

//Ŀ
//Restaura a entrada da rotina                                            
//
aCols 	:= aClone(aSavCols)
aHeader	:= aClone(aSavHead)
N		:= nSavN
oGetD:oBrowse:lDisablePaint:= .F.

RestArea( aArea ) 

Return(Nil)

/*

Ŀ
Funo    AT450Bar2  Autor  Vendas Clientes        Data  29.01.99 
Ĵ
Descrio  Mostra a EnchoiceBar na tela                               
Ĵ
 Uso       TECA450                                                    
ٱ


*/
Static Function AT450Bar2(oDlg,bOk,bCancel,nOpc,oGetD)

Local aButtons := {}

aAdd(aButtons,{"PESQUISA",{ || At450Laud2(oGetD)}, STR0003, STR0033}) //"Visualizar"

//Ŀ
// Adiciona botoes do usuario na EnchoiceBar                              
//
If ExistBlock( "U_AT450BU2" ) 
	aUsButtons := ExecBlock( "U_AT450BU2", .F., .F. ) 
	aEval( aUsButtons, { |x| aAdd( aButtons, x ) } ) 	 	
EndIf 	

Return (EnchoiceBar(oDlg,bOK,bcancel,,aButtons))

/*/


Ŀ
Funcao    At450Laud2 Autor  Vendas Clientes        Data  29.01.99 
Ĵ
Descrio Visualizacao Individual do Laudo ( TECA460 )                
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosExcO1 : Objeto Getdados                                     
                                                                      
ٱ


/*/
Static Function AT450Laud2(oGetD)

Local aArea 		:= { Alias() , IndexOrd() , RecNo() }
Local aSavHeader	:= aClone(aHeader)
Local aSavCols    := aClone(aCols)
Local nSavN			:= If(Type("N")=="U",1,N)
Local nPosNumOs   := aScan(aHeader,{|x| AllTrim(x[2])=="AB9_NUMOS"})
Local cLaudo      := aCols[nSavN][nPosNumOs] + GDFieldGet( "AB9_CODTEC", nSavN ) + GDFieldGet( "AB9_SEQ", nSavN ) 

oGetD:oBrowse:lDisablePaint := .T.

DbSelectArea("AB9")
DbSetOrder(1)
If ( DbSeek(xFilial("AB9")+cLaudo) )
	At460Visua("AB9",AB9->(RecNo()),2)
EndIf

//Ŀ
//Restaura a Rotina                                                       
//
aHeader := aClone(aSavHeader)
oGetD:oBrowse:lDisablePaint := .F.

DbSelectArea(aArea[1])
DbSetOrder(aArea[2])
DbGoTo(aArea[3])

Return(Nil)

/*


Ŀ
Funcao    At450Track Autor  Vendas Clientes        Data 09/01/2002
Ĵ
Descrio  Faz o tratamento da chamada do System Tracker              
Ĵ
Retorno    .T.                                                        
Ĵ
Parametros Nenhum                                                     
ٱ


*/
Static Function AT450Track() 

Local aEnt     := {}								// Itens para rastreamento
Local cNumOs   := M->AB6_NUMOS 						// Numero da OS
Local nPosItem := GDFieldPos( "AB7_ITEM" ) 		    // Posicao do item AB7_ITEM
Local nLoop    := 0 								// Utilizado no loop
Local oOldDlg        := oDlg						// Salva as variaveis estaticas
Local oOldSay1       := oSay1						// Salva as variaveis estaticas
Local oOldSay2       := oSay2                  		// Salva as variaveis estaticas
Local oOldSay3       := oSay3						// Salva as variaveis estaticas
Local cOldPictureTot := cPictureTot					// Salva as variaveis estaticas

//Ŀ
// Carrega os itens para rastreamento          
//
For nLoop := 1 To Len( aCols ) 
	aAdd( aEnt, { "AB7", cNumOs + aCols[ nLoop, nPosItem ] } ) 
Next nLoop 

MaTrkShow( aEnt ) 

//Ŀ
//Restaura as variaveis estaticas, pois a rotina MaTrShow 
//reabre a janela TECA450 novamente, caso solicitado pelo 
//usuario.                                                
//
oDlg		:= oOldDlg
oSay1		:= oOldSay1
oSay2		:= oOldSay2
oSay3		:= oOldSay3
cPictureTot	:= cOldPictureTot
           
Return( .T. ) 

/*/

Ŀ
Funo    MyTeca450  Autor  Vendas Clientes        Data 01/06/2004 
Ĵ
          Rotina de teste da rotina automatica do programa TECA450     
                                                                       
Ĵ
ParametrosNenhum                                                       
                                                                       
Ĵ
Retorno   Nenhum                                                       
                                                                       
Ĵ
Descrio Esta rotina tem como objetivo efetuar testes na rotina de    
          chamado tecnico.                                             
                                                                       
Ĵ
Uso        Materiais                                                   
ٱ


/*/
User Function MyTeca450()

Local lOk      := .T.
Local aCabec   := {}
Local aItem    := {}
Local aItens   := {}
Local aApont   := {}
Local aAponts  := {}
Local cNumOS   := ""

Private lMsErroAuto := .F.

//Ŀ
//| Abertura do ambiente                                         |
//
ConOut(Repl("-",80))
PREPARE ENVIRONMENT EMPRESA "99" FILIAL "01" MODULO "TEC" TABLES "SA1","SE4","DA0","AA3","AAG","AA5","SB1","AA5","AB6","AB7","AB8"

//Ŀ
//| Verificacao do ambiente para teste                           |
//
DbSelectArea("SA1")
DbSetOrder(1)
If !SA1->(DbSeek(xFilial("SA1")+"00000101"))
	lOk := .F.
	ConOut("Cadastrar Cliente: 000001 Loja: 01")
EndIf

DbSelectArea("SB1")
DbSetOrder(1)
If !SB1->(DbSeek(xFilial("SB1")+"000001"))
	lOk := .F.
	ConOut("Cadastrar Produto: 000001")
EndIf

DbSelectArea("SB1")
DbSetOrder(1)
If !SB1->(DbSeek(xFilial("SB1")+"000002"))
	lOk := .F.
	ConOut("Cadastrar Produto: 000002")
EndIf

DbSelectArea("SE4")
DbSetOrder(1)
If !SE4->(DbSeek(xFilial("SE4")+"001"))
	lOk := .F.
	ConOut("Cadastrar Condicao de Pagamento: 001")
EndIf

DbSelectArea("SE4")
DbSetOrder(1)
If !SE4->(DbSeek(xFilial("SE4")+"002"))
	lOk := .F.
	ConOut("Cadastrar Condicao de Pagamento: 002")
EndIf

/*DbSelectArea("AA3")
DbSetOrder(1)
If !AA3->(DbSeek(xFilial("AA3")+"00000101"+PadR("000001",15)+"123456"))
	lOk := .F.
	ConOut("Cadastrar Base Instalada Cliente/Loja: 000001/01 Produto: 000001 Srie: 123456")
EndIf*/

/*DbSelectArea("AA3")
DbSetOrder(1)
If !AA3->(DbSeek(xFilial("AA3")+"00000101"+PadR("000002",15)+"654321"))
	lOk := .F.
	ConOut("Cadastrar Base Instalada Cliente/Loja: 000001/01 Produto: 000002 Srie: 654321")
EndIf*/

DbSelectArea("AAG")
DbSetOrder(1)
If !AAG->(DbSeek(xFilial("AAG")+"000001"))
	lOk := .F.
	ConOut("Cadastrar Ocorrencia: 000001")
EndIf

DbSelectArea("AA5")
DbSetOrder(1)
If !AA5->(DbSeek(xFilial("AA5")+"000001"))
	lOk := .F.
	ConOut("Cadastrar Servico: 000001")
EndIf


If lOk
	ConOut(PadC("Teste de Inclusao da OS",80))
	ConOut("Inicio: "+Time())
	cNumOS := GetSXENum("AB6","AB6_NUMOS")
	//RollBackSx8()
	aAdd(aCabec,{"AB6_NUMOS",cNumOS,Nil})
	aAdd(aCabec,{"AB6_CODCLI",SA1->A1_COD,Nil})
	aAdd(aCabec,{"AB6_LOJA"  ,SA1->A1_LOJA,Nil})
	aAdd(aCabec,{"AB6_EMISSA",dDataBase,Nil})
	aAdd(aCabec,{"AB6_ATEND" ,cUserName,Nil})
	aAdd(aCabec,{"AB6_CONPAG","001",Nil})
	aAdd(aCabec,{"AB6_HORA"  ,Time(),Nil})

	aAdd(aItem,{"AB7_ITEM"  ,StrZero(1,2),Nil})
	aAdd(aItem,{"AB7_TIPO"  ,"1",Nil})
	aAdd(aItem,{"AB7_CODPRO",AB7->AB7_CODPRO,Nil})
	aAdd(aItem,{"AB7_NUMSER",AB7->AB7_NUMSER,Nil})
	aAdd(aItem,{"AB7_CODPRB",AAG->AAG_CODPRB,Nil})
	aAdd(aItens,aItem)

	aAdd(aApont,{"AB8_ITEM"  ,StrZero(1,2),Nil})
	aAdd(aApont,{"AB8_SUBITE",StrZero(1,2),Nil})
	aAdd(aApont,{"AB8_CODPRO",SB1->B1_COD,Nil})
	aAdd(aApont,{"AB8_CODSER",AA5->AA5_CODSER,Nil})
	aAdd(aApont,{"AB8_QUANT",1,Nil})
	aAdd(aApont,{"AB8_VUNIT",100,Nil})
	aAdd(aApont,{"AB8_PRCLIS",100,Nil})
	aAdd(aAponts,aApont)

	TECA450(,aCabec,aItens,aAponts,3)
	If !lMsErroAuto
		ConOut("Inclusao com sucesso! ")
	Else
		ConOut("Erro na inclusao!")
	EndIf
	aCabec := {}
	aItem  := {}
	aItens := {}
	aApont := {}
	aAponts:= {}

	ConOut(PadC("Teste de Alteracao da OS",80))
	aAdd(aCabec,{"AB6_NUMOS",cNumOS,Nil})
	aAdd(aCabec,{"AB6_CODCLI",SA1->A1_COD,Nil})
	aAdd(aCabec,{"AB6_LOJA"  ,SA1->A1_LOJA,Nil})
	aAdd(aCabec,{"AB6_EMISSA",dDataBase,Nil})
	aAdd(aCabec,{"AB6_ATEND" ,cUserName,Nil})
	aAdd(aCabec,{"AB6_CONPAG","002",Nil})
	aAdd(aCabec,{"AB6_HORA"  ,Time(),Nil})

	aAdd(aItem,{"LINPOS","AB7_ITEM","01"})
	aAdd(aItem,{"AB7_ITEM"  ,StrZero(1,2),Nil})
	aAdd(aItem,{"AB7_TIPO"  ,"1",Nil})
	aAdd(aItem,{"AB7_CODPRO","000002",Nil})
	aAdd(aItem,{"AB7_NUMSER","654321",Nil})
	aAdd(aItem,{"AB7_CODPRB",AAG->AAG_CODPRB,Nil})
	aAdd(aItens,aItem)

	aAdd(aApont,{"LINPOS","AB8_SUBITE","01"})
	aAdd(aApont,{"AB8_SUBITE",StrZero(1,2),Nil})
	aAdd(aApont,{"AB8_CODPRO","000002",Nil})
	aAdd(aApont,{"AB8_CODSER",AA5->AA5_CODSER,Nil})
	aAdd(aApont,{"AB8_QUANT",1,Nil})
	aAdd(aApont,{"AB8_VUNIT",100,Nil})
	aAdd(aApont,{"AB8_PRCLIS",100,Nil})
	aAdd(aAponts,aApont)

	TECA450(,aCabec,aItens,aAponts,4)
	If !lMsErroAuto
		ConOut("Alteracao com sucesso! ")
	Else
		ConOut("Erro na Alteracao!")
	EndIf
	aCabec := {}
	aItem  := {}
	aItens := {}
	aApont := {}
	aAponts:= {}

	ConOut(PadC("Teste de Exclusao da OS",80))
	aAdd(aCabec,{"AB6_NUMOS",cNumOS,Nil})
	aAdd(aCabec,{"AB6_CODCLI",SA1->A1_COD,Nil})
	aAdd(aCabec,{"AB6_LOJA"  ,SA1->A1_LOJA,Nil})
	aAdd(aCabec,{"AB6_EMISSA",dDataBase,Nil})
	aAdd(aCabec,{"AB6_ATEND" ,cUserName,Nil})
	aAdd(aCabec,{"AB6_CONPAG","002",Nil})
	aAdd(aCabec,{"AB6_HORA"  ,Time(),Nil})

	aAdd(aItem,{"AB7_ITEM"  ,StrZero(1,2),Nil})
	aAdd(aItem,{"AB7_TIPO"  ,"1",Nil})
	aAdd(aItem,{"AB7_CODPRO","000002",Nil})
	aAdd(aItem,{"AB7_NUMSER","654321",Nil})
	aAdd(aItem,{"AB7_CODPRB",AAG->AAG_CODPRB,Nil})
	aAdd(aItens,aItem)

	aAdd(aApont,{"AB8_SUBITE",StrZero(1,2),Nil})
	aAdd(aApont,{"AB8_CODPRO","000002",Nil})
	aAdd(aApont,{"AB8_CODSER",AA5->AA5_CODSER,Nil})
	aAdd(aApont,{"AB8_QUANT",1,Nil})
	aAdd(aApont,{"AB8_VUNIT",100,Nil})
	aAdd(aApont,{"AB8_PRCLIS",100,Nil})
	aAdd(aAponts,aApont)

	TECA450(,aCabec,aItens,aAponts,5)
	If !lMsErroAuto
		ConOut("Exclusao com sucesso! ")
	Else
		ConOut("Erro na Exclusao!")
	EndIf
	aCabec := {}
	aItem  := {}
	aItens := {}
	aApont := {}
	aAponts:= {}

	ConOut("Fim  : "+Time())

EndIf

RESET ENVIRONMENT
Return(.T.)


/*


Ŀ
Program    At450Leg  Autor  Vendas Clientes        Data 12/04/2006
Ĵ
Descrio  Exibe a legenda da Ordem de Servico                        
Ĵ
Retorno    Nil                                                        
Ĵ
Parametros Nenhum                                                     
ٱ


*/
USer Function AT450Leg() 


BrwLegenda( cCadastro, STR0035, ;								//"Status"
							{ { "BR_VERDE"  ,  STR0036 },; 	//"Aberta"
							{  "BR_AMARELO"  , "Liberado Faturamento"},; 	//"Faturamento"							
							{ "BR_VERMELHO" ,  STR0037 }}  )  	//"Encerrada"

Return( Nil ) 

/*


Ŀ
Funo    At450Moeda Autor  Vendas Clientes        Data 19/05/2006
Ĵ
Descrio  Verifica se a moeda do Orcamento esta cadastrada           
Ĵ
 Uso       TECA450                                                    
ٱ


*/
User Function AT450MoedaOK()

Local lRet 		:= .T.					//Indica o retorno da funcao
Local aAreaAB6	:= AB6->(GetArea()) 	//Guarda a area corrente

If (AB6->AB6_MOEDA <> 0) .AND. ( AB6->( FieldPos("AB6_TXMOED") ) > 0 )
	If AB6->AB6_TXMOED <= 0                                                          
		If Recmoeda( dDatabase, AB6->AB6_MOEDA ) <= 0
			//"No existe taxa para a Moeda " #
			//" informada nesta OS. Favor cadastr-la antes de efetivar."
			//"OS: " ######
			MsgAlert( STR0040 + StrZero(AB6->AB6_MOEDA,1) + STR0041 , STR0042 + AB6->AB6_NUMOS ) 
			lRet := .F.
		EndIf
	EndIf
EndIf  

RestArea(aAreaAB6)

Return (lRet)


/*/


Ŀ
Funcao    At450Pict  Autor  Vendas Clientes        Data  12.06.06 
Ĵ
Descrio  Atualiza picture dos valores do Rodape conforme Moeda      
Ĵ
Retorno   Nenhum                                                      
Ĵ
Parametros                                                            
                                                                      
ٱ


/*/
User Function AT450Pict()

Local nMoeda := M->AB6_MOEDA			// Moeda informada no cabecalho

//
// Atualiza picture 
//
cPictureTot	:= PesqPict("AB8","AB8_TOTAL",14,nMoeda) 

//
// Efetua um refresh nos objetos c/ a nova Picture 
//
oSay1:Refresh()
oSay2:Refresh()
oSay3:Refresh()

//Ŀ
// Recalcula os totais do Rodape da tela  
//
At450Total(oDlg, .F.)

Return(.T.)  

/*User Function ALTER450()        


SetPrvt("COPCAO,NOPCE,NOPCG,NUSADO,AHEADER,ACOLS")
SetPrvt("_NI,_NPOSNUM,_NPOSLIN,_NPOSDATA,_NPOSVALOR,_NPOSDEL")
SetPrvt("CTITULO,CALIASENCHOICE,CALIASGETD,CLINOK,CTUDOK,CFIELDOK")
SetPrvt("ACPOENCHOICE,_LRET,NIT,")



dbSelectArea("AB7")
If EOF() .And. BOF()
    Help("",1,"ARQVAZIO")
    Return
Endif



cOpcao := "ALTERAR"

Do Case
    Case cOpcao == "INCLUIR"    ; nOpcE := 2 ; nOpcG := 3
    Case cOpcao == "ALTERAR"    ; nOpcE := 2 ; nOpcG := 3
    Case cOpcao == "VISUALIZAR" ; nOpcE := 2 ; nOpcG := 2
EndCase


RegToMemory("AB7",(cOpcao == "INCLUIR"))



nUsado  := 0
dbSelectArea("SX3")
dbSeek("AB7")
aHeader := {}
While !Eof().And.(x3_arquivo=="AB7")
    If Upper(AllTrim(X3_CAMPO)) == "AB7_NUMOS"
        dbSkip()
        Loop
    Endif
    If X3USO(x3_usado) .And. cNivel >= x3_nivel
    	nUsado:=nUsado+1
        Aadd(aHeader,{ TRIM(x3_titulo), x3_campo, x3_picture,;
             x3_tamanho, x3_decimal,X3_VALID,;
    	     x3_usado, x3_tipo, x3_arquivo, x3_context } )
	Endif
    dbSkip()
End

If cOpcao == "INCLUIR"
    aCols := {Array(nUsado+1)}
	aCols[1,nUsado+1]:=.F.
	For _ni:=1 to nUsado
		aCols[1,_ni]:=CriaVar(aHeader[_ni,2])
	Next
Else
	aCols:={}
    dbSelectArea("AB7")
    dbSetOrder(1)
    dbSeek(xFilial("AB7")+AB6->AB6_NUMOS)
    While !eof() .and. xFilial() == AB6->AB6_FILIAL .And. ;
          AB6->AB6_NUMOS == M->AB7_NUMOS

		AADD(aCols,Array(nUsado+1))
		For _ni:=1 to nUsado
            If Upper(AllTrim(aHeader[_ni,10])) != "V" // Campo Real
                aCols[Len(aCols),_ni]:=FieldGet(FieldPos(aHeader[_ni,2]))
            Else // Campo Virtual
                aCols[Len(aCols),_ni]:=CriaVar(aHeader[_ni,2])
            Endif
        Next 
		aCols[Len(aCols),nUsado+1]:=.F.
		dbSkip()

	End
Endif



_nPosNum   := aScan(aHeader,{|x| AllTrim(Upper(x[2]))=="AB7_ITEM" })
_nPosLin   := aScan(aHeader,{|x| AllTrim(Upper(x[2]))=="AB7_PRODUTO" })
_nPosData  := aScan(aHeader,{|x| AllTrim(Upper(x[2]))=="AB7_NUMOS"})
_nPosValor := aScan(aHeader,{|x| AllTrim(Upper(x[2]))=="AB7_VALOR"})
_nPosDel   := Len(aHeader) + 1



cTitulo        := "Alterar"
cAliasEnchoice := "AB7"
cAliasGetD     := "AB6"
cLinOk         := 'ExecBlock("U_AT450EFET",.F.,.F.)'
cTudOk         := "AllwaysTrue()"
cFieldOk       := "AllwaysTrue()"
aCpoEnchoice   := {"AB7_NUMOS"}

_lRet := Modelo3(cTitulo,cAliasEnchoice,cAliasGetD,aCpoEnchoice,cLinOk,cTudOk,nOpcE,nOpcG,cFieldOk)

If _lRet
    Grava()
Endif

Return */


Static Function Grava()


For nIt := 1 To Len(aCols)
    If !aCols[nIt,_nPosDel]
        dbSelectArea("AB7")
        dbSetOrder(1)
        If !dbSeek(xFilial()+aCols[nIt,_nPosNum]+aCols[nIt,_nPosLin]+M->AB6_NUMOS)
            RecLock("AB7",.T.)
            AB7->AB7_FILIAL := xFilial()
            AB7->AB7_NUMOS := M->AB6_NUMOS
            AB7->AB7_ITEM    := aCols[nIt,_nPosNum]
            AB7->AB7_PRODUTO  := aCols[nIt,_nPosLin]
            AB7->AB7_VALOR  := aCols[nIt,_nPosValor]
            MsUnLock()
        Else
            RecLock("AB7",.F.)
            AB7->AB7_NUMOS   := aCols[nIt,_nPosData]
            AB7->AB7_VALOR  := aCols[nIt,_nPosValor]
            MsUnLock()
        Endif
    Else
        dbSelectArea("AB7")
        dbSetOrder(1)
        If dbSeek(xFilial()+aCols[nIt,_nPosNum]+aCols[nIt,_nPosLin]+M->AB7_NUMOS)
            RecLock("AB7",.F.)
            dbDelete()
            MsUnLock()
            dbSelectArea("SX2")
            dbSeek("AB7")
            RecLock("SX2",.F.)
            SX2->X2_DELET := SX2->X2_DELET + 1
            MsUnLock()
        Endif
    Endif
Next nIt

dbSelectArea("AB6")

Return